SystemOrganization addCategory: #'ST2JS-Core'!
SystemOrganization addCategory: #'ST2JS-Base'!
SystemOrganization addCategory: #'ST2JS-SUnit'!
SystemOrganization addCategory: #'ST2JS-Tests'!

!String methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/22/2006 12:58'!
printJsString

	| result |

	result := self.
	
	result := result copyReplaceAll: '\' with: '\\'.
	result := result copyReplaceAll: String cr with: '\n'.
	result := result copyReplaceAll: String tab with: '\t'.
	result := result copyReplaceAll: '''' with: '\'''.
	
	^ '''' , result , ''''
! !

!VariableNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:43'!
hasBlockNodeWithReturn
	^ false! !

!VariableNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/19/2006 10:55'!
isInstance

	^ self type = 1! !

!VariableNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/20/2006 18:04'!
isSuper
	^ (self == NodeSuper)! !

!VariableNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/19/2006 10:56'!
isTemporary

	^ self type = 2! !

!VariableNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/2/2006 14:08'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	(self == NodeSelf) ifTrue:[
		aStream nextPutAll: 'self'.
		^ self
	].
	
	(self == NodeNil) ifTrue:[
		aStream nextPutAll: 'null'.
		^ self
	].
	
	(self == NodeTrue) ifTrue:[
		aStream nextPutAll: 'true'.
		^ self
	].

	(self == NodeFalse) ifTrue:[
		aStream nextPutAll: 'false'.
		^ self
	].

	(self == NodeSuper) ifTrue:[
		aStream nextPutAll: 'self.uber'.
		^ self
	].

	self isInstance ifTrue:[
		aStream nextPutAll: 'self._' ,  self name.
		^ self
	].

	"JS Class Name?"
	Smalltalk
		at: name asSymbol
		ifPresent:[:klass |
			(klass includesBehavior: S2SObject) ifTrue:[
				aStream nextPutAll: klass jsClassName.
				^ self
			]
		].

	"Just the name"
	aStream nextPutAll: self name.
! !

!SelectorNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/19/2006 14:12'!
selector
	^ key! !

!MethodNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 12:27'!
hasBlockNodeWithReturn

	^ block statements anySatisfy:[:each | each hasBlockNodeWithReturn]
! !

!MethodNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:40'!
jsMethodSourceWithBlocksSourceOn: aStream translator: aTranslator

	self flag: #todo. "create an methodId to be checked in the catch(err) "

	aStream nextPutAll: '	var __returnValue__ = new ST.ReturnValue(self);'; cr.
	aStream nextPutAll: '	try {'; cr.

	block jsInlinedSourceOn: aStream level: 1 translator: aTranslator.

	aStream nextPutAll: '	}'; cr.
	aStream nextPutAll: '	catch (err) {'; cr.
	aStream nextPutAll: '		if (err === __returnValue__) {'; cr.
	aStream nextPutAll: '			return err._value;'; cr.
	aStream nextPutAll: '		}'; cr.
	aStream nextPutAll: '		throw err;'; cr.
	aStream nextPutAll: '	}'; cr.
! !

!MethodNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:31'!
jsMethodSourceWithoutBlocksSourceOn: aStream translator: aTranslator

	block jsInlinedSourceOn: aStream level: 0 translator: aTranslator.
! !

!MethodNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:31'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	| |
	aStream
		nextPutAll: 'function('.

	arguments
		do:[:each | aStream nextPutAll: each name]
		separatedBy: [ aStream nextPutAll: ', '].

	aStream
		nextPutAll: ') {';
		cr.

	"undefined is not an option in ST"
	arguments do:[:each |
		anInteger + 1 timesRepeat: [aStream tab].
			
		aStream nextPutAll: each name , ' = (typeof ' , each name , ' == ''undefined'') ? null : ' , each name , ';' ; cr
	].

	"self is this, but point to the 'correct' receiver for inner functions"
	anInteger + 1 timesRepeat: [aStream tab].
	aStream nextPutAll: 'var self = this;'; cr.

	temporaries isEmpty ifFalse:[
		anInteger + 1 timesRepeat: [aStream tab].
		aStream nextPutAll: 'var '.
		temporaries
			do:[:each | aStream nextPutAll: each name]
			separatedBy: [ aStream nextPutAll: ', '].
		aStream nextPutAll: ';'; cr.
	].

	self hasBlockNodeWithReturn
		ifTrue:[ self jsMethodSourceWithBlocksSourceOn: aStream translator: aTranslator]
		ifFalse:[ self jsMethodSourceWithoutBlocksSourceOn: aStream translator: aTranslator].

	anInteger timesRepeat: [aStream tab].
	aStream nextPutAll: '}'; cr.
! !

!ReturnNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:31'!
hasBlockNodeWithReturn
	^ expr hasBlockNodeWithReturn! !

!ReturnNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/26/2006 21:03'!
isReturnNode
	^ true! !

!ReturnNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:40'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	anInteger timesRepeat: [aStream tab].

	aStream nextPutAll: '%return%('.

	aStream nextPutAll: (expr jsSourceLevel: anInteger translator: aTranslator) withoutLeadingBlanks.
	
	aStream nextPutAll: ');'.! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:31'!
hasBlockNodeWithReturn
	
	(selector selector asString beginsWith: 'inline') ifTrue:[^ false].
	(selector selector == #jsLiteral:inSmalltalk:) ifTrue:[^ false].
		
	^ (receiver notNil and:[receiver hasBlockNodeWithReturn]) or:[arguments anySatisfy:[:each | each notNil and:[each hasBlockNodeWithReturn]]].
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:28'!
jsInlineDoOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'var __receiver__ = '.
	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ';'; cr.
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: 'for(var __i__ = 0; __i__ < __receiver__.length; __i__++) {'; cr.

	anInteger + 1 timesRepeat:[aStream tab].
	aStream nextPutAll: 'var '.
	arguments first arguments first jsSourceOn: aStream level: 0 translator: aTranslator.
	aStream nextPutAll: ' = __receiver__[__i__];'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:29'!
jsInlineIfFalseOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'if (!!'.
	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ') {'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:29'!
jsInlineIfTrueIfFalseOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'if ('.
	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ') {'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'; cr.

	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: 'else {'; cr.

	arguments second jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.

	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:29'!
jsInlineIfTrueOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'if ('.
	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ') {'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:26'!
jsInlineIsEmptyOn: aStream level: anInteger translator: aTranslator

	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: '.length == 0'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:26'!
jsInlineNotEmptyOn: aStream level: anInteger translator: aTranslator

	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: '.length !!= 0'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:29'!
jsInlineToByDoOn: aStream level: anInteger translator: aTranslator

	| argName |
	
	arguments seventh isNil ifFalse:[
		aStream nextPutAll: 'var '.
		arguments first jsSourceOn: aStream level: anInteger translator: aTranslator.
		aStream nextPutAll: '; '.
		arguments seventh jsSourceOn: aStream level: anInteger translator: aTranslator.
		aStream nextPutAll: '; '; cr.

		anInteger timesRepeat:[aStream tab].
	].

	argName := arguments third arguments first jsSourceLevel: 0 translator: aTranslator.

	aStream nextPutAll: 'for(var '.
	aStream nextPutAll: argName.
	aStream nextPutAll: ' = '.
	receiver jsSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: '; '.
	aStream nextPutAll: argName.
	aStream nextPutAll: ' <= '.
	arguments first jsSourceOn: aStream level: anInteger translator: aTranslator..
	aStream nextPutAll: '; '.
	aStream nextPutAll: argName.
	aStream nextPutAll: ' += '.
	arguments second jsSourceOn: aStream level: anInteger translator: aTranslator..
	aStream nextPutAll: ') {'; cr.
	arguments third jsInlinedSourceOn: aStream level: anInteger translator: aTranslator..
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'.
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:29'!
jsInlineWhileFalseOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'while (!!('.
	receiver jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ')) {'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:30'!
jsInlineWhileTrueOn: aStream level: anInteger translator: aTranslator

	aStream nextPutAll: 'while ('.
	receiver jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	aStream nextPutAll: ') {'; cr.

	arguments first jsInlinedSourceOn: aStream level: anInteger translator: aTranslator.
	
	anInteger timesRepeat:[aStream tab].
	aStream nextPutAll: '}'! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:32'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	| jsCodeOrSelector |

	anInteger timesRepeat: [aStream tab].
		
	jsCodeOrSelector := aTranslator selectorMappingFor: self.

	jsCodeOrSelector isSymbol ifTrue:[
		self perform: jsCodeOrSelector withArguments: {aStream. anInteger. aTranslator}.
	]
	ifFalse:[
		| jsCode |
		jsCode := self replacingVariablesLevel: anInteger jsCode: jsCodeOrSelector translator: aTranslator.
		aStream nextPutAll: jsCode.
	].
! !

!MessageNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:52'!
replacingVariablesLevel: levelInteger jsCode: jsCode translator: aTranslator

	| result variables |

	result := jsCode.
	
	variables := Dictionary new.

	(jsCode includesSubString: '%receiver%') ifTrue:[
		receiver notNil ifTrue:[
			variables at: '%receiver%' put: (receiver jsSourceLevel: levelInteger translator: aTranslator) withoutLeadingBlanks.
		].
	].

	(jsCode includesSubString: '%tabs%') ifTrue:[
		| tabs |
		tabs := String streamContents:[:stream | levelInteger timesRepeat: [stream tab]].
		variables at: '%tabs%' put: tabs.
	].

	((jsCode includesSubString: '%args') or:[jsCode includesSubString: 'Args%']) ifTrue:[
		| args commaArgs argsComma |

		args := String new writeStream.
		commaArgs := String new writeStream.
		argsComma := String new writeStream.

		arguments
			do:[:each |
				each isNil ifFalse:[
					| eachJsSource |
					eachJsSource := each jsSourceLevel: levelInteger + 1 translator: aTranslator.
			
					args nextPutAll: eachJsSource.
					commaArgs nextPutAll: ', ' , eachJsSource.
					argsComma nextPutAll: eachJsSource , ', '.
				].
			]
			separatedBy:[args nextPutAll: ', '].

		variables at: '%args%' put: args contents.
		variables at: '%commaArgs%' put: commaArgs contents.
		variables at: '%argsComma%' put: argsComma contents.
	].

	(jsCode includesSubString: '%arg') ifTrue:[
		arguments withIndexDo:[:each :index |
			each isNil ifFalse:[
				variables at: ('%arg' , index asString , '%') put: (each jsSourceLevel: levelInteger + 1 translator: aTranslator).
			].
		].
	].

	(jsCode includesSubString: '%selectorAsJsMethodName%') ifTrue:[
		variables at: '%selectorAsJsMethodName%' put: (aTranslator convertSelectorToJsMethodName: selector selector).
	].
	
	receiver isNil ifFalse:[
		(receiver isLiteral and: [receiver isConstantNumber]) ifTrue:[
			result := result copyReplaceAll: '%receiver%.' with: '(%receiver%).'.
		].
	].

	variables keysAndValuesDo:[:key :value |
		result := result copyReplaceAll: key with: value.
	].

	^ result.! !

TestCase subclass: #S2STest
	instanceVariableNames: 'translator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Tests'!

!S2STest methodsFor: 'running' stamp: 'dgd 7/31/2006 21:22'!
setUp
	translator := S2STranslator new.
	translator showSmalltalkSource: false.
	translator showMethodComments: false.! !

!S2STest methodsFor: 'running' stamp: 'dgd 7/31/2006 20:06'!
testConstructors

	| result1 result2 result3 result4 |
	
	result1 := translator constructorFor: S2SObject.
	self should:[result1 = 'ST.Object = function() {
}'].

	result2 := translator constructorFor: S2SSimplest.
	self should:[result2 = 'ST.Simplest = function() {
}'].

	result3 := translator constructorFor: S2SFooBar.
	self should:[result3 = 'ST.FooBar = function() {
	this._foo = null;
	this._bar = null;
}'].

	result4 := translator constructorFor: S2SFooBarXxx.	
	self should:[result4 = 'ST.FooBarXxx = function() {
	this._foo = null;
	this._bar = null;
	this._xxx = null;
}'].! !

!S2STest methodsFor: 'running' stamp: 'dgd 7/31/2006 19:55'!
testInheritances

	| result1 result2 result3 result4 |
	
	result1 := translator inheritanceFor: S2SObject.
	self should:[result1 = ''].

	result2 := translator inheritanceFor: S2SSimplest.
	self should:[result2 = 'ST.Simplest.superclass_(ST.Object);'].

	result3 := translator inheritanceFor: S2SFooBar.
	self should:[result3 = 'ST.FooBar.superclass_(ST.Object);'].

	result4 := translator inheritanceFor: S2SFooBarXxx.	
	self should:[result4 = 'ST.FooBarXxx.superclass_(ST.FooBar);'].
! !

!S2STest methodsFor: 'running' stamp: 'dgd 7/31/2006 11:34'!
testJavascriptClassName

	self should:[S2SObject jsClassName = 'ST.Object'].
	self should:[S2SSimplest jsClassName = 'ST.Simplest'].
	self should:[S2SFooBar jsClassName = 'ST.FooBar'].

	self should:[S2SObjectExtension jsClassName = 'Object'].
	self should:[S2SArrayExtension jsClassName = 'Array'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:38'!
testMethodAdd

	
	| result |
	result := translator methodSourceFor: S2SPoint selector: #+.
	
	self should:[result = 'ST.Point.prototype.__add__ = function(aPointOrNumber) {
	aPointOrNumber = (typeof aPointOrNumber == ''undefined'') ? null : aPointOrNumber;
	var self = this;
	var aPoint;
	aPoint = aPointOrNumber.asPoint();
	return (self._x.__add__(aPoint.x()).__at__(self._y.__add__(aPoint.y())));
};'].
! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:38'!
testMethodBar

	| result1 result2 result3 result4 |
	
	result1 := translator methodSourceFor: S2SFooBar selector: #bar.
	
	self should:[result1 = 'ST.FooBar.prototype.bar = function() {
	var self = this;
	return (self._bar);
};'].

	result2 :=translator methodSourceFor:  S2SFooBar selector: #bar:.
	
	self should:[result2 = 'ST.FooBar.prototype.bar_ = function(anObject) {
	anObject = (typeof anObject == ''undefined'') ? null : anObject;
	var self = this;
	self._bar = anObject;
	return (self);
};'].

	result3 := translator methodSourceFor: S2SFooBarXxx selector: #bar:.
	
	self should:[result3 = 'ST.FooBarXxx.prototype.bar_ = function(anObject) {
	anObject = (typeof anObject == ''undefined'') ? null : anObject;
	var self = this;
	self.uber(''bar_'', ST.ifNil(anObject, function () {
				return 0
			} ));
	return (self);
};'].

	result4 := translator methodSourceFor: S2SFooBarXxx selector: #bar.
	
	self should:[result4 = 'ST.FooBarXxx.prototype.bar = function() {
	var self = this;
	return (self.uber(''bar'').__add__(1));
};'].
! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:39'!
testMethodCascade

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #cascade.
	
	self should:[result = 'ST.FooBarXxx.prototype.cascade = function() {
	var self = this;
	var pepe, y;
	pepe = (1).__at__(2);
	y = (function(__receiver__) { __receiver__.x(); return __receiver__.y(); })(pepe);
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:39'!
testMethodCascade2

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #cascade2.
	
	self should:[result = 'ST.FooBarXxx.prototype.cascade2 = function() {
	var self = this;
	var pepe;
	pepe = (10).__at__(22);
	return ((function(__receiver__) { __receiver__.x(); return __receiver__.y(); })(pepe));
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:39'!
testMethodClassSide

	| result1 result2 |
	
	result1 := translator classMethodSourceFor: S2SFooBar selector: #isFooBar.
	
	self should:[result1 = 'ST.FooBar.isFooBar = function() {
	var self = this;
	return (true);
};'].

	result2 := translator classMethodSourceFor: S2SFooBarXxx selector: #isFooBar.
	
	self should:[result2 = 'ST.FooBarXxx.isFooBar = function() {
	var self = this;
	return (true);
};'].
! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:40'!
testMethodDo1

	| result |

	result := translator methodSourceFor: S2SFooBarXxx selector: #do1.
	
	self should:[result = 'ST.FooBarXxx.prototype.do1 = function() {
	var self = this;
	self.collection().do_(function (each) {
			each = (typeof each == ''undefined'') ? null : each;
			return each.className()
		});
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:40'!
testMethodDo2

	| result |

	result := translator methodSourceFor: S2SFooBarXxx selector: #do2.
	
	self should:[result = 'ST.FooBarXxx.prototype.do2 = function() {
	var self = this;
	var __returnValue__ = new ST.ReturnValue(self);
	try {
		self.collection().do_(function (each) {
				each = (typeof each == ''undefined'') ? null : each;
				throw __returnValue__.value_(each.className());
			});
		return (self);
	}
	catch (err) {
		if (err === __returnValue__) {
			return err._value;
		}
		throw err;
	}
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:40'!
testMethodFoo

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #foo.
	
	self should:[result = 'ST.FooBarXxx.prototype.foo = function() {
	var self = this;
	return (self._foo);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:40'!
testMethodFooBar

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #foo:bar:.
	
	self should:[result = 'ST.FooBarXxx.prototype.foo_bar_ = function(fooObject, barObject) {
	fooObject = (typeof fooObject == ''undefined'') ? null : fooObject;
	barObject = (typeof barObject == ''undefined'') ? null : barObject;
	var self = this;
	self._foo = fooObject;
	self.bar_(barObject);
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:41'!
testMethodHasBar

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #hasBar.
	
	self should:[result = 'ST.FooBarXxx.prototype.hasBar = function() {
	var self = this;
	return (!!((self._bar == null)));
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:41'!
testMethodHasFoo

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #hasFoo.
	
	self should:[result = 'ST.FooBarXxx.prototype.hasFoo = function() {
	var self = this;
	return ((self._foo !!= null));
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:41'!
testMethodInlines1

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines1.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines1 = function() {
	var self = this;
	if ((1 > 2)) {
		return (1);
	}
	return (2);
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:41'!
testMethodInlines2

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines2.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines2 = function() {
	var self = this;
	if ((1 > 2)) {
		return (1);
	}
	else {
		return (2);
	}
	return (self);
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:41'!
testMethodInlines3

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines3.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines3 = function() {
	var self = this;
	if (!!(1 > 2)) {
		return (2);
	}
	return (1);
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:41'!
testMethodInlines4

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines4.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines4 = function() {
	var self = this;
	var __receiver__ = self.collection();
	for(var __i__ = 0; __i__ < __receiver__.length; __i__++) {
		var each = __receiver__[__i__];
		each.foo();
	}
	return (self);
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:42'!
testMethodInlines5

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines5.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines5 = function() {
	var self = this;
	while (false) {
		self.foo();
	}
	return (self);
};'].! !

!S2STest methodsFor: 'running - inlines' stamp: 'dgd 8/1/2006 13:42'!
testMethodInlines6

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #inlines6.
	
	self should:[result = 'ST.FooBarXxx.prototype.inlines6 = function() {
	var self = this;
	while (!!(true)) {
		self.foo();
	}
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:42'!
testMethodInstantiation

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #instantiate.
	
	self should:[result = 'ST.FooBarXxx.prototype.instantiate = function() {
	var self = this;
	var test1, test2, test3;
	test1 = ST.FooBar.__new__();
	test2 = ST.FooBar.__new__();
	(test1.bar() > test2.bar()).ifTrue_(function () {
			return test1 = test2
		});
	test3 = ST.FooBar.foo_bar_(''foo'', ''bar'');
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:10'!
testMethodLoops

	| result |

	result := translator methodSourceFor: S2SFooBarXxx selector: #loops.
	
	self should:[result ='ST.FooBarXxx.prototype.loops = function() {
	var self = this;
	var a;
	a = Array.new_(5);
	var indexLimiT; indexLimiT = a.length; 
	for(var index = 2; index <= indexLimiT; index++) {
		a[index - 1] = index.__mul__(2);
	}
	var jjLimiT; jjLimiT = a.length; 
	for(var jj = 1; jj <= jjLimiT; jj += 2) {
		a[jj - 1] = a[jj - 1].__mul__(2);
	}
	a.do_(function (each) {
			each = (typeof each == ''undefined'') ? null : each;
			return self.bar_(each)
		});
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:42'!
testMethodLoops2

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #loops2.
	
	self should:[result = 'ST.FooBarXxx.prototype.loops2 = function() {
	var self = this;
	var a;
	a = Array.new_(5);
	for(var index = 1; index <= 5; index++) {
		a[index - 1] = index;
	}
	for(var index = a.length.__sub__(1); index <= 5; index++) {
		a[index - 1] = index.__mul__(2);
	}
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:42'!
testMethodReset

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #reset.
	
	self should:[result = 'ST.FooBarXxx.prototype.reset = function() {
	var self = this;
	self.foo_bar_(null, null);
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:43'!
testMethodString

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #string.
	
	self should:[result = 'ST.FooBarXxx.prototype.string = function() {
	var self = this;
	var strCr, strTab, strQuoted, strBackSlash;
	strCr = ''\n'';
	strTab = ''\t'';
	strQuoted = ''\'''';
	strBackSlash = ''\\'';
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 8/1/2006 13:43'!
testMethodWhile

	| result |

	result := translator methodSourceFor: S2SFooBarXxx selector: #methodWhile.
	
	self should:[result = 'ST.FooBarXxx.prototype.methodWhile = function() {
	var self = this;
	(function () {
		return false
	}).whileTrue_(function () {
			return (1).__add__(1)
		});
	return (self);
};'].! !

!S2STest methodsFor: 'running - methods' stamp: 'dgd 7/31/2006 21:29'!
testMethodXxxxxx

	| result |
	
	result := translator methodSourceFor: S2SFooBarXxx selector: #xxxxxx.
	
	self should:[result = 'ST.FooBarXxx.prototype.xxxxxx = function() {
	var self = this;
	var x;
	(1 > 3).ifTrue_(function () {
			return self.bar_(1)
		});
	((1 >= 3) && (1 <= 5)).ifTrue_ifFalse_(function () {
			return self.bar_(2)
		}, function () {
			return self.bar_(3)
		});
	true.ifFalse_(function () {
			return self.bar_(10)
		});
	self.hasBar().ifTrue_(function () {
			return alert(''has bar!!'')
		});
	x = ST.ifNil(self.bar(), function () {
		return 1
	} );
	return (self);
};'].! !

!S2STest methodsFor: 'running' stamp: 'dgd 8/2/2006 13:34'!
testSimplest

	| result |
	
	result := translator sourceForClass: S2SSimplest.
	
	self should:[result = '/**-----------------------------------------------------------**/
/** Generated from: S2SSimplest **/
/** constructor **/
ST.Simplest = function() {
}

/** inheritance **/
ST.Simplest.superclass_(ST.Object);

/** loaded class **/
ST.LoadedClasses.push(ST.Simplest)

/** class name **/
ST.Simplest.__className__ = ''ST.Simplest'';
ST.Simplest.prototype.__className__ = ''ST.Simplest'';

/** class methods **/
ST.Simplest.initialize = ST.Object.initialize;
ST.Simplest.loadedClasses = ST.Object.loadedClasses;
ST.Simplest.loadedClassesNames = ST.Object.loadedClassesNames;

/** instance methods **/
/**-----------------------------------------------------------**/'].! !

!LiteralNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:43'!
hasBlockNodeWithReturn
	^ false! !

!LiteralNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:39'!
jsSourceOn: aStream level: anInteger translator: aTranslator
	aStream nextPutAll: self literalValue printJsString! !

!Object methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/22/2006 12:47'!
printJsString
	^ self printString! !

Object subclass: #S2SObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

S2SObject subclass: #S2SFooBar
	instanceVariableNames: 'foo bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Tests'!

!S2SFooBar class methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:13'!
foo: fooObject bar: barObject
	^ self new initializeFoo: fooObject bar: barObject! !

!S2SFooBar class methodsFor: 'testing' stamp: 'dgd 7/23/2006 11:34'!
isFooBar
	"Answer if the receiver is a Foo Bar"

	^ true! !

!S2SFooBar methodsFor: 'accessing' stamp: 'dgd 7/18/2006 20:17'!
bar
	"Answer the receiver's bar"
	^ bar! !

!S2SFooBar methodsFor: 'accessing' stamp: 'dgd 7/20/2006 17:58'!
bar: anObject
	"Change the receiver's bar"
	bar := anObject! !

!S2SFooBar methodsFor: 'accessing' stamp: 'dgd 7/23/2006 16:43'!
foo
	^ foo! !

!S2SFooBar methodsFor: 'initialization' stamp: 'dgd 7/31/2006 13:14'!
initializeFoo: fooObject bar: barObject
	foo := fooObject.
	bar := barObject.! !

S2SFooBar subclass: #S2SFooBarXxx
	instanceVariableNames: 'xxx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Tests'!

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/20/2006 10:41'!
bar
	"Change the receiver's bar"
	^ super bar + 1! !

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/22/2006 20:04'!
bar: anObject
	"Change the receiver's bar"
	super bar: (anObject ifNil:[0])! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/21/2006 14:52'!
cascade

	| pepe y |
	pepe := 1 @ 2.
	y := pepe x; y.! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/21/2006 14:42'!
cascade2

	| pepe |
	pepe := 10 @ 22.
	^ pepe x; y! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 15:08'!
collection
	^ {1. 2. true. 'string'}! !

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/27/2006 15:24'!
do1
	self collection
		do: [:each | each className]! !

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/27/2006 15:24'!
do2
	self collection
		do: [:each | ^ each className]! !

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/18/2006 19:59'!
foo
	"Answer the receiver's foo"
	^ foo! !

!S2SFooBarXxx methodsFor: 'accessing' stamp: 'dgd 7/19/2006 11:37'!
foo: fooObject bar: barObject
	"Change the receiver's foo and bar"
	foo := fooObject.
	self bar: barObject.! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/19/2006 13:30'!
hasBar
	^ bar isNil not! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/19/2006 12:36'!
hasFoo
	^ foo ~= nil! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 12:21'!
inlines1
	(1 > 2)
		inlineIfTrue:[^ 1].
	^ 2! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 12:21'!
inlines2
	(1 > 2)
		inlineIfTrue:[^ 1]
		ifFalse:[^ 2].! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 12:21'!
inlines3
	(1 > 2)
		inlineIfFalse:[^ 2].
	^ 1
! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 12:22'!
inlines4
	self collection inlineDo:[:each |
		each foo.
	]! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 13:09'!
inlines5
	[false] inlineWhileTrue:[self foo]! !

!S2SFooBarXxx methodsFor: 'inlines' stamp: 'dgd 7/27/2006 13:09'!
inlines6
	[true] inlineWhileFalse:[self foo]! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/31/2006 13:15'!
instantiate
	| test1 test2 test3 |

	test1 := S2SFooBar new.
	test2 := S2SFooBar new.
	
	test1 bar > test2 bar
		ifTrue:[test1 := test2].

	test3 := S2SFooBar foo: 'foo' bar: 'bar'.
	! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/21/2006 12:00'!
loops
	| a |
	a := Array new: 5.
	
	2 to: a size do:[:index | a at: index put: index * 2].
	
	1 to: a size by: 2 do:[:jj | a at: jj put: (a at: jj) * 2].

	a do:[:each | self bar: each].
! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/21/2006 21:44'!
loops2
	| a |

	a := Array new: 5.
	
	1 to: 5 do:[:index | a at: index put: index].
	(a size - 1) to: 5 do:[:index | a at: index put: index * 2].
! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/22/2006 20:02'!
methodWhile

	[false] whileTrue:[ 1 + 1]! !

!S2SFooBarXxx methodsFor: 'reseting' stamp: 'dgd 7/19/2006 12:46'!
reset
	self foo: nil bar: nil! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/22/2006 12:58'!
string
	| strCr strTab strQuoted strBackSlash |

	strCr := '
'.

	strTab := '	'.

	strQuoted := ''''.
	
	strBackSlash := '\'! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/20/2006 15:06'!
xxxxxx

	| x |
	1 > 3
		ifTrue:[self bar: 1].

	(1 between: 3 and: 5)
		ifTrue:[self bar: 2]
		ifFalse:[self bar: 3].

	true ifFalse:[self bar: 10].

	self hasBar ifTrue:[self inform: 'has bar!!'].
	
	x := self bar ifNil:[1]! !

!S2SFooBarXxx methodsFor: 'testing' stamp: 'dgd 7/27/2006 16:00'!
yyy
	^ 1 > 3
		ifTrue:[1]
		ifFalse:[ 2]
"
	| block |
	block := [^ 2].
	block value.
	^ 1
	"! !

S2SObject subclass: #S2SInspector
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SInspector class methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:17'!
inspect: anObject 
	"Answer an instance of me to provide an inspector for anObject."
	
	"We call basicNew to avoid a premature initialization; the instance method 
	inspect: anObject will do a self initialize."

	^ self new initializeObject: anObject.! !

!S2SInspector class methodsFor: 'user interface' stamp: 'dgd 7/24/2006 19:23'!
openOn: anObject
	^ (self inspect: anObject) open! !

!S2SInspector methodsFor: 'initialization' stamp: 'dgd 7/31/2006 13:17'!
initializeObject: anObject
	object := anObject! !

!S2SInspector methodsFor: 'private' stamp: 'dgd 7/30/2006 21:06'!
inspectHtmlSource

	| string source stream |

	string := object printString.
	source := object sourceCode.

	stream := S2SStringExtension new writeStream.

	stream nextPutAll: '<table border="1" cellspacing="0" cellpadding="1" width="100%" height="100%">'.

	stream nextPutAll: '<tr bgcolor="#99aaff" align="left">'.
	stream nextPutAll: '<th colspan="3">'.
	stream nextPutAll: object className.
	stream nextPutAll: '</th>'.
	stream nextPutAll: '</tr>'.

	stream nextPutAll: '<tr>'.
	stream nextPutAll: '<td>self</td>'.
	stream nextPutAll: '<td colspan="2">'.
	stream nextPutAll: string.
	stream nextPutAll: '</td>'.
	stream nextPutAll: '</tr>'.

	object instVarNames do:[:each |
		stream nextPutAll: '<tr>'.
		stream nextPutAll: '<td>'.
		stream nextPutAll: each.
		stream nextPutAll: '</td>'.
		stream nextPutAll: '<td>'.
		stream nextPutAll: (object valueOfInstVarNamed: each) printString.
		stream nextPutAll: '</td>'.
		stream nextPutAll: '<td>'.
		stream nextPutAll: '<input type="button" value="inspect" onClick="window.__model__.inspectInstVarNamed_(''' , each , ''')">'.
		stream nextPutAll: '</td>'.
		stream nextPutAll: '</tr>'.
	].

	source notEmpty inlineIfTrue:[
		stream nextPutAll: '<tr><td colspan="3">'.
		stream nextPutAll: '<tt>'.
		stream nextPutAll: source.
		stream nextPutAll: '</tt>'.
		stream nextPutAll: '</td></tr>'.
	].

	stream nextPutAll: '</table>'.

	^ stream contents.
! !

!S2SInspector methodsFor: 'user interface' stamp: 'dgd 7/25/2006 13:27'!
inspectInstVarNamed: each

	(object valueOfInstVarNamed: each) inspect.
! !

!S2SInspector methodsFor: 'user interface' stamp: 'dgd 7/25/2006 13:13'!
open

	"self openAsAlert."
	self openAsWindow.
	! !

!S2SInspector methodsFor: 'private' stamp: 'dgd 7/30/2006 21:06'!
openAsAlert

	| string source msg |

	string := object printString.
	source := object sourceCode.

	msg := string , S2SStringExtension cr , S2SStringExtension cr , source.
	
	self
		jsLiteral: 'alert ( msg )'
		inSmalltalk: [Transcript show: msg; cr]
! !

!S2SInspector methodsFor: 'private' stamp: 'dgd 8/1/2006 13:45'!
openAsWindow
	"
	self openAsWindow.
	"

	| insW msg |

	msg := self inspectHtmlSource.

	insW := self
				jsLiteral: 'window.open("", "", "toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=20, height=20")'
				inSmalltalk:[insW := nil].
	
	self
		jsLiteral: '
					if (insW) {
						insW.document.writeln(msg);
						insW.__model__ = self;
					} else {
						self.openAsAlert();
						return self;
					}'
		inSmalltalk: [
			Transcript show: msg; cr.
			^ self
		].

	self resizeWindow: insW.
! !

!S2SInspector methodsFor: 'private' stamp: 'dgd 7/27/2006 15:20'!
resizeWindow: insW

	| table |
	
	insW isNil inlineIfFalse:[
		table := self
						jsLiteral: 'insW.document.getElementsByTagName("Table")[0]'
						inSmalltalk:[nil].

		table isNil inlineIfFalse: [
			self jsLiteral: 'insW.resizeTo(table.clientWidth + 100, table.clientHeight + 125)'.
		].
	].
! !

!S2SObject class methodsFor: 'class initialization' stamp: 'dgd 8/2/2006 13:43'!
initialize
	"
	self inform: self name , ' Loaded!!'
	"
! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 7/31/2006 11:43'!
jsClassName

	| jsClassName namespace |

	jsClassName := self name asString.

	(jsClassName beginsWith: 'S2S')
		ifTrue:[jsClassName := jsClassName allButFirst: 3].

	namespace := 'ST'.

	^ namespace , '.' , jsClassName
! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 7/31/2006 17:03'!
jsClassesToInclude

	| result |
	
	result := Set new.

	result add: S2SReturnValue.
	result add: S2SInspector.
	result add: S2SWriteStream.

	result addAll: S2SObjectExtension withAllSubclasses.

	^ result
! !

!S2SObject class methodsFor: 'testing' stamp: 'dgd 8/1/2006 11:19'!
jsGoesBefore: aClass

	(self jsIsExtension and:[ aClass jsIsExtension not] )
		ifTrue:[ ^ true ].

	(self jsIsExtension not and:[ aClass jsIsExtension] )
		ifTrue:[ ^ false ].

	self allSuperclasses size < aClass allSuperclasses size
		ifTrue:[^ true].

	self allSuperclasses size > aClass allSuperclasses size
		ifTrue:[^ false].

	^ self jsClassName < aClass jsClassName.
! !

!S2SObject class methodsFor: 'testing' stamp: 'dgd 7/23/2006 16:18'!
jsIsExtension
	^ false! !

!S2SObject class methodsFor: 'testing' stamp: 'dgd 8/1/2006 11:12'!
jsIsRoot
	^ self == S2SObject! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 8/2/2006 13:40'!
jsPostSource
	^ '/* Invoque class initialization */
for (var key in ST.LoadedClasses) {
	var klass = ST.LoadedClasses[key];
	if (klass.initialize) {
		if (klass == ST.Object) {
			//ST.log("Initializating " + klass.asClassName() + "...");
			klass.initialize();
		}
		else {
			if (klass.initialize !!== ST.Object.initialize) {
				//ST.log("Initializating " + klass.asClassName() + "...");
				klass.initialize();
			}
		}
	}
};

//alert (ST.LoadedClasses.length + " loaded classes");
'! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 8/1/2006 14:18'!
jsPreSource
	^ '/* Smalltalk namespace */
var Smalltalk = {
	ID: 0,
	
	LoadedClasses: [],
	
	/** utilities functions **/	
	ifNil: function(receiver, alternativeBlock) {
		return (receiver == null) ? alternativeBlock() : receiver;
	},
	
	toString: function(receiver) {
		return (receiver == null) ? "null" : receiver.toString();
	},
	
	printString: function(receiver) {
		return (receiver == null) ? "null" : receiver.printString();
	},
	
	printOn_: function(receiver, aStream) {
		if (receiver == null) {
			aStream.nextPutAll_("null");
		}
		else {
			receiver.printOn_(aStream);
		}
	},
	
	log: function(msg) {
		if (!!console) {
			return;
		}
		
		// Try lo log using Firebug
		console.log(msg);
	}
};

var ST = Smalltalk;
'! !

!S2SObject class methodsFor: 'as yet unclassified' stamp: 'dgd 8/2/2006 13:53'!
jsSuperclasses
	^ self jsIsRoot
					ifTrue: [ {} ]
					ifFalse: [ (self allSuperclasses copyUpTo: S2SObject)  , {S2SObject} ].
! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 7/26/2006 11:52'!
jsWithAllClassesToInclude

	| result |

	result := Set new.

	self jsWithAllClassesToInclude: result.

	^ result! !

!S2SObject class methodsFor: 'javascript-translation' stamp: 'dgd 7/26/2006 11:53'!
jsWithAllClassesToInclude: aSet

	(aSet includes: self) ifTrue:[^ self].
	
	aSet add: self.
	self jsClassesToInclude do:[:each |
		each jsWithAllClassesToInclude: aSet
	].
! !

!S2SObject class methodsFor: 'accessing - loaded classes' stamp: 'dgd 7/31/2006 10:37'!
loadedClasses
	^ self jsLiteral: 'ST.LoadedClasses'! !

!S2SObject class methodsFor: 'accessing - loaded classes' stamp: 'dgd 8/1/2006 14:30'!
loadedClassesNames
	^ self loadedClasses collect:[:each | each name]! !

!S2SObject methodsFor: 'converting' stamp: 'dgd 7/23/2006 15:29'!
asString
	^ self printString! !

!S2SObject methodsFor: 'class membership' stamp: 'dgd 8/1/2006 13:45'!
class
	^ self
			jsLiteral: 'eval( self.className() )'
			inSmalltalk:[super class].! !

!S2SObject methodsFor: 'accessing' stamp: 'dgd 8/1/2006 13:45'!
className
	^ self
			jsLiteral: 'self.__className__'
			inSmalltalk: [self class name asString]! !

!S2SObject methodsFor: 'accessing' stamp: 'dgd 8/1/2006 13:45'!
id
	^ self jsLiteral: 'self.__id__'! !

!S2SObject methodsFor: 'initialization' stamp: 'dgd 8/1/2006 13:45'!
initialize
	self
		jsLiteral: 'self.__id__ = ST.ID++'
		inSmalltalk: []
! !

!S2SObject methodsFor: 'inspecting' stamp: 'dgd 7/24/2006 19:25'!
inspect

	S2SInspector openOn: self.! !

!S2SObject methodsFor: 'accessing - instance variables' stamp: 'dgd 7/25/2006 13:03'!
instVarNames

	| result |
	
	self
			jsLiteral: ''
			inSmalltalk: [^ self class instVarNames].

	result := OrderedCollection new.
	
	self jsLiteral: 'for (var k in this) { if (typeof this[k] !!= ''function'') { result.push(k) } }'.
	"
	self jsLiteral: 'for (var k in this) { if (typeof this[k] == ''function'') { result.push(k) } }'.
	"
	
	^ result
! !

!S2SObject methodsFor: 'testing' stamp: 'dgd 8/1/2006 14:33'!
isExtension
	^ false! !

!S2SObject methodsFor: 'utilities' stamp: 'dgd 7/31/2006 20:59'!
jsLiteral: aString
	self error: 'Not valid in Smalltalk'! !

!S2SObject methodsFor: 'utilities' stamp: 'dgd 7/20/2006 14:40'!
jsLiteral: aString inSmalltalk: aBlock
	^ aBlock value! !

!S2SObject methodsFor: 'converting' stamp: 'dgd 7/28/2006 17:26'!
printOn: aStream
	aStream nextPutAll: 'a '.
	aStream nextPutAll: self className.! !

!S2SObject methodsFor: 'converting' stamp: 'dgd 7/30/2006 21:05'!
printString
	^ S2SStringExtension streamContents:[:stream | self printOn: stream]! !

!S2SObject methodsFor: 'inspecting' stamp: 'dgd 8/1/2006 13:45'!
sourceCode
	^ self
			jsLiteral: 'self.toSource ? this.toSource() : '''''
			inSmalltalk: ['']
! !

!S2SObject methodsFor: 'accessing - instance variables' stamp: 'dgd 7/24/2006 21:19'!
valueOfInstVarNamed: aString
	^ self instVarNamed: aString! !

S2SObject subclass: #S2SObjectExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

S2SObjectExtension subclass: #S2SArrayExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SArrayExtension class methodsFor: 'as yet unclassified' stamp: 'dgd 8/1/2006 14:46'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	| result |
	result := self new: aCollection size.
	aCollection withIndexDo:[:each :index | result at: index put: each].
	^ result
	! !

!S2SArrayExtension methodsFor: 'adding' stamp: 'dgd 8/1/2006 14:47'!
addAll: aCollection
	aCollection inlineDo:[:each | self add: each].
	^ aCollection! !

!S2SArrayExtension methodsFor: 'accessing' stamp: 'dgd 7/25/2006 16:54'!
className
	^ 'Array'! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:35'!
collect: aBlock
	| result |
	result := OrderedCollection new.
	self inlineDo:[:each |
		result add: (aBlock value: each)
	].
	^ result! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:35'!
collect: collectBlock thenDo: doBlock 
	"Utility method to improve readability."
	
	self inlineDo:[:each |
		doBlock value: (collectBlock value: each)
	].
! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:34'!
do: elementBlock
	self inlineDo:[:each |
		elementBlock value: each.
	]! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:39'!
do: elementBlock separatedBy: separatorBlock
	"Evaluate the elementBlock for all elements in the receiver,
	and evaluate the separatorBlock between."

	| beforeFirst | 

	beforeFirst := true.

	self inlineDo: [:each |
		beforeFirst
			inlineIfTrue: [beforeFirst := false]
			ifFalse: [separatorBlock value].
		elementBlock value: each
	].! !

!S2SArrayExtension methodsFor: 'accessing - instance variables' stamp: 'dgd 7/24/2006 21:21'!
instVarNames
	| result |
	result := OrderedCollection new.
	result add: 'length'.
	self withIndexDo:[:each :index | result add: index].
	^ result! !

!S2SArrayExtension methodsFor: 'testing' stamp: 'dgd 7/27/2006 15:18'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!S2SArrayExtension methodsFor: 'testing' stamp: 'dgd 7/27/2006 15:18'!
notEmpty
	^ self isEmpty not! !

!S2SArrayExtension methodsFor: 'converting' stamp: 'dgd 7/27/2006 13:40'!
printOn: aStream

	aStream nextPutAll: '#('.
	
	self
		do: [:each | aStream nextPutAll: each printString]
		separatedBy: [ aStream nextPutAll: ' '].

	aStream nextPutAll: ')'
! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:39'!
reject: aBlock
	| result |
	result := OrderedCollection new.
	self inlineDo:[:each |
		(aBlock value: each)
			inlineIfFalse:[result add: each]
	].
	^ result! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:39'!
select: aBlock
	| result |
	result := OrderedCollection new.
	self inlineDo:[:each |
		(aBlock value: each)
			inlineIfTrue:[result add: each]
	].
	^ result! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 13:39'!
select: selectBlock thenDo: doBlock 

	self inlineDo:[:each |
		(selectBlock value: each)
			inlineIfTrue:[doBlock value: each]
	].
! !

!S2SArrayExtension methodsFor: 'accessing - instance variables' stamp: 'dgd 7/27/2006 13:40'!
valueOfInstVarNamed: aStringOrNumber
	aStringOrNumber = 'length'
			inlineIfTrue:[ ^ self size ]
			ifFalse: [ ^ self at: aStringOrNumber].
! !

!S2SArrayExtension methodsFor: 'enumerating' stamp: 'dgd 7/27/2006 17:13'!
withIndexDo: elementBlock
	| index |
	index := 1.
	self inlineDo:[:each |
		elementBlock value: each value: index.
		index := index + 1.
	]! !

S2SObjectExtension subclass: #S2SBooleanExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SBooleanExtension methodsFor: 'accessing' stamp: 'dgd 7/25/2006 16:52'!
className
	^ 'Boolean'! !

!S2SBooleanExtension methodsFor: 'controlling' stamp: 'dgd 7/27/2006 18:40'!
ifFalse: falseAlternativeBlock
	| result |
	
	self = true
		inlineIfTrue: [result := nil]
		ifFalse: [result := falseAlternativeBlock value].

	^ result! !

!S2SBooleanExtension methodsFor: 'controlling' stamp: 'dgd 7/27/2006 18:40'!
ifTrue: trueAlternativeBlock
	| result |
	
	self = true
		inlineIfTrue: [result := trueAlternativeBlock value]
		ifFalse: [result := nil].

	^ result! !

!S2SBooleanExtension methodsFor: 'controlling' stamp: 'dgd 7/27/2006 18:41'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock
	| result |
	
	self = true
		inlineIfTrue: [result := trueAlternativeBlock value]
		ifFalse: [result := falseAlternativeBlock value].

	^ result.
! !

!S2SBooleanExtension methodsFor: 'converting' stamp: 'dgd 7/27/2006 15:10'!
printOn: aStream
	
	self = true
		inlineIfTrue:[aStream nextPutAll: 'true']
		ifFalse:[aStream nextPutAll: 'false'].
! !

S2SObjectExtension subclass: #S2SErrorExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SErrorExtension methodsFor: 'accessing' stamp: 'dgd 7/27/2006 13:24'!
className
	^ 'Error'! !

S2SObjectExtension subclass: #S2SFunctionExtension
	instanceVariableNames: 'superclass subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SFunctionExtension methodsFor: 'accessing class hierarchy' stamp: 'dgd 8/1/2006 14:41'!
addSubclass: aClass
	subclasses isNil
		ifTrue:[subclasses := OrderedCollection new].
	subclasses add: aClass! !

!S2SFunctionExtension methodsFor: 'accessing class hierarchy' stamp: 'dgd 8/1/2006 14:44'!
allSubclasses
	"Answer a Set of the receiver's and the receiver's descendent's subclasses. "

	| scan scanTop |
	scan := OrderedCollection withAll: self subclasses.
	scanTop := 1.
	[scanTop > scan size]
		whileFalse: [scan addAll: (scan at: scanTop) subclasses.
			scanTop := scanTop + 1].
	^ scan! !

!S2SFunctionExtension methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 17:31'!
basicNew
	^ self jsLiteral: 'new this()'! !

!S2SFunctionExtension methodsFor: 'accessing' stamp: 'dgd 7/25/2006 16:54'!
className
	^ 'Function'! !

!S2SFunctionExtension methodsFor: 'exceptions' stamp: 'dgd 7/27/2006 17:02'!
ensure: aBlock
	| error |

	error := nil.
	
	self
		jsLiteral: 'try {
	self();
}
catch (err) {
	error = err;
}'
		inSmalltalk: [self halt].

	aBlock value.

	error isNil inlineIfFalse:[
		self jsLiteral: 'throw error'.
	].! !

!S2SFunctionExtension methodsFor: 'converting' stamp: 'dgd 8/1/2006 14:30'!
name

	^ self
		jsLiteral: 'self.__className__'
		inSmalltalk:[self class name asString].
! !

!S2SFunctionExtension methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 17:31'!
new
	^ self basicNew initialize! !

!S2SFunctionExtension methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:12'!
new: anInteger
	^ self jsLiteral: 'new this(anInteger)'! !

!S2SFunctionExtension methodsFor: 'converting' stamp: 'dgd 7/25/2006 16:55'!
printOn: aStream
	aStream nextPutAll: self asString! !

!S2SFunctionExtension methodsFor: 'accessing class hierarchy' stamp: 'dgd 8/1/2006 14:41'!
subclasses
	^ subclasses ifNil:[{}]! !

!S2SFunctionExtension methodsFor: 'accessing' stamp: 'dgd 7/31/2006 17:19'!
superclass
	^ superclass! !

!S2SFunctionExtension methodsFor: 'accessing class hierarchy' stamp: 'dgd 8/1/2006 14:40'!
superclass: parent
	"
	from http://javascript.crockford.com/inheritance.html
	"

	| d p |
	d := 0.

	superclass := parent.
	
	self jsLiteral: '
	p = (this.prototype = new parent());

	this.prototype.uber = function(name) {
		var f, r, t = d, v = parent.prototype;
		if (t) {
			while (t) {
				v = v.constructor.prototype;
				t -= 1;
			}
			f = v[name];
		}
		else {
			f = p[name];
			if (f == this[name]) {
				f = v[name];
			}
		}
		d += 1;
		r = f.apply(this, Array.prototype.slice.apply(arguments, [1]));
		d -= 1;
		return r;
	}
'.

	parent addSubclass: self.

	^ self
! !

!S2SFunctionExtension methodsFor: 'controlling' stamp: 'dgd 7/27/2006 13:47'!
whileFalse: aBlock
	[self value] inlineWhileFalse: [aBlock value]! !

!S2SFunctionExtension methodsFor: 'controlling' stamp: 'dgd 7/27/2006 13:47'!
whileTrue: aBlock
	[self value] inlineWhileTrue: [aBlock value]! !

S2SObjectExtension subclass: #S2SNumberExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SNumberExtension methodsFor: 'arithmetic' stamp: 'dgd 7/23/2006 16:24'!
* aNumber
	^ self jsLiteral: 'self * aNumber'! !

!S2SNumberExtension methodsFor: 'arithmetic' stamp: 'dgd 7/23/2006 16:22'!
+ aNumber
	^ self jsLiteral: 'self + aNumber'! !

!S2SNumberExtension methodsFor: 'arithmetic' stamp: 'dgd 7/23/2006 16:25'!
- aNumber
	^ self jsLiteral: 'self - aNumber'! !

!S2SNumberExtension methodsFor: 'arithmetic' stamp: 'dgd 7/23/2006 16:25'!
/ aNumber
	^ self jsLiteral: 'self / aNumber'! !

!S2SNumberExtension methodsFor: 'converting' stamp: 'dgd 7/23/2006 16:28'!
@ aNumber
	^ S2SPoint x: self y: aNumber! !

!S2SNumberExtension methodsFor: 'arithmetic' stamp: 'dgd 7/23/2006 16:25'!
abs
	^ self jsLiteral: 'Math.abs(self)'! !

!S2SNumberExtension methodsFor: 'converting' stamp: 'dgd 7/23/2006 16:28'!
asPoint
	^ S2SPoint x: self y: self! !

!S2SNumberExtension methodsFor: 'accessing' stamp: 'dgd 7/25/2006 16:54'!
className
	^ 'Number'! !

!S2SNumberExtension methodsFor: 'printing' stamp: 'dgd 7/23/2006 16:26'!
printOn: aStream
	aStream nextPutAll: self asString! !

!S2SObjectExtension class methodsFor: 'nil' stamp: 'dgd 7/31/2006 11:43'!
jsClassName

	| jsClassName |

	jsClassName := super jsClassName.

	"Extensions go to 'root' namespace"
	(jsClassName beginsWith: 'ST.')
		ifTrue:[jsClassName := jsClassName allButFirst: 3].

	(jsClassName size > 9 and:[jsClassName endsWith: 'Extension'])
		ifTrue:[jsClassName := jsClassName allButLast: 9].

	^ jsClassName.
! !

!S2SObjectExtension class methodsFor: 'nil' stamp: 'dgd 7/26/2006 11:34'!
jsIsExtension
	^ true! !

!S2SObjectExtension methodsFor: 'converting' stamp: 'dgd 7/25/2006 11:14'!
asString
	^ self printString! !

!S2SObjectExtension methodsFor: 'accessing' stamp: 'dgd 7/31/2006 10:41'!
className
	^ 'Object'! !

!S2SObjectExtension methodsFor: 'initialization' stamp: 'dgd 7/31/2006 17:32'!
initialize
	! !

!S2SObjectExtension methodsFor: 'inspecting' stamp: 'dgd 7/24/2006 19:25'!
inspect

	S2SInspector openOn: self.! !

!S2SObjectExtension methodsFor: 'accessing - instance variables' stamp: 'dgd 7/31/2006 10:45'!
instVarNames
	| result |
	result := OrderedCollection new.

	self
		jsLiteral: ''
		inSmalltalk: [^ {}].

	self
		jsLiteral: 'for (k in this) {
	var v = this[k];
	if (typeof v !!= "function") {
		result.push(k);
	}
}'.

^ result! !

!S2SObjectExtension methodsFor: 'testing' stamp: 'dgd 8/1/2006 14:32'!
isExtension
	^ true! !

!S2SObjectExtension methodsFor: 'converting' stamp: 'dgd 7/27/2006 18:34'!
printOn: aStream
	aStream nextPutAll: 'a '.
	aStream nextPutAll: self className! !

!S2SObjectExtension methodsFor: 'converting' stamp: 'dgd 7/30/2006 21:06'!
printString
	^ S2SStringExtension streamContents:[:stream | self printOn: stream]! !

!S2SObjectExtension methodsFor: 'inspecting' stamp: 'dgd 8/1/2006 13:45'!
sourceCode
	^ self
			jsLiteral: 'self.toSource ? this.toSource() : '''''
			inSmalltalk: ['']
! !

!S2SObjectExtension methodsFor: 'accessing - instance variables' stamp: 'dgd 7/31/2006 10:47'!
valueOfInstVarNamed: aString
	^ self instVarNamed: aString! !

S2SObjectExtension subclass: #S2SStringExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SStringExtension class methodsFor: 'instance creation' stamp: 'dgd 7/24/2006 12:18'!
cr
	^ '
'! !

!S2SStringExtension class methodsFor: 'stream creation' stamp: 'dgd 7/23/2006 16:33'!
streamContents: blockWithArg
	| stream |
	stream := S2SWriteStream new.
	blockWithArg value: stream.
	^ stream contents.! !

!S2SStringExtension class methodsFor: 'instance creation' stamp: 'dgd 7/24/2006 12:18'!
tab
	^ '	'! !

!S2SStringExtension methodsFor: 'accessing' stamp: 'dgd 7/27/2006 20:51'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!S2SStringExtension methodsFor: 'converting' stamp: 'dgd 7/25/2006 11:12'!
asString
	^ self! !

!S2SStringExtension methodsFor: 'accessing' stamp: 'dgd 7/25/2006 16:54'!
className
	^ 'String'! !

!S2SStringExtension methodsFor: 'copying' stamp: 'dgd 8/1/2006 13:46'!
copyFrom: start to: stop 
	^ self jsLiteral:'(self).slice(start - 1, stop)'! !

!S2SStringExtension methodsFor: 'accessing' stamp: 'dgd 8/1/2006 13:46'!
findString: subString
	^ self jsLiteral: '((self).indexOf(subString) + 1)'! !

!S2SStringExtension methodsFor: 'accessing' stamp: 'dgd 7/27/2006 21:01'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!S2SStringExtension methodsFor: 'testing' stamp: 'dgd 7/27/2006 21:07'!
ifEmpty: aBlock
	"Evaluate the block if I'm empty"

	^ self isEmpty ifTrue: aBlock! !

!S2SStringExtension methodsFor: 'testing' stamp: 'dgd 7/27/2006 15:19'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!S2SStringExtension methodsFor: 'testing' stamp: 'dgd 7/27/2006 15:19'!
notEmpty
	^ self isEmpty not! !

!S2SStringExtension methodsFor: 'converting' stamp: 'dgd 7/27/2006 18:37'!
printOn: aStream
	aStream nextPutAll: ''''.
	aStream nextPutAll: self.
	aStream nextPutAll: ''''.! !

!S2SStringExtension methodsFor: 'converting' stamp: 'dgd 7/28/2006 19:07'!
writeStream
	^ S2SWriteStream new! !

S2SObject subclass: #S2SPoint
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Base'!

!S2SPoint class methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:15'!
x: xNumber y: yNumber
	^ self new initializeX: xNumber y: yNumber.! !

!S2SPoint methodsFor: 'aritmethic' stamp: 'dgd 7/22/2006 15:14'!
+ aPointOrNumber
	| aPoint |
	aPoint := aPointOrNumber asPoint.
	^ (x + aPoint x) @ (y + aPoint y)
! !

!S2SPoint methodsFor: 'aritmethic' stamp: 'dgd 7/22/2006 15:16'!
abs
	"Answer a Point whose x and y are the absolute values of the receiver's x 
	and y."

	^ x abs @ y abs! !

!S2SPoint methodsFor: 'converting' stamp: 'dgd 7/22/2006 15:15'!
asPoint
	^ self! !

!S2SPoint methodsFor: 'initialization' stamp: 'dgd 8/1/2006 12:53'!
initializeX: xNumber y: yNumber
	x := xNumber.
	y := yNumber.! !

!S2SPoint methodsFor: 'printing' stamp: 'dgd 7/25/2006 12:27'!
printOn: aStream 
	"The receiver prints on aStream in terms of infix notation."

	x printOn: aStream.
	aStream nextPutAll: '@'.
	y printOn: aStream.
! !

!S2SPoint methodsFor: 'accessing' stamp: 'dgd 7/20/2006 13:30'!
x
	"Answer the receiver's x"
	^ x! !

!S2SPoint methodsFor: 'accessing' stamp: 'dgd 7/20/2006 13:30'!
y
	"Answer the receiver's y"
	^ y! !

S2SObject subclass: #S2SReturnValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SReturnValue methodsFor: 'accessing' stamp: 'dgd 7/27/2006 14:06'!
value: anObject
	value := anObject! !

S2SObject subclass: #S2SSimplest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Tests'!

S2SObject subclass: #S2STestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

S2STestCase subclass: #S2SBaseTestCase
	instanceVariableNames: 'setUpCalled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2SBaseTestCase class methodsFor: 'javascript-generation' stamp: 'dgd 7/22/2006 20:45'!
jsClassesToInclude
	^ {S2SFooBar. S2SFooBarXxx}! !

!S2SBaseTestCase methodsFor: 'initialization' stamp: 'dgd 7/25/2006 09:57'!
initialize
	super initialize.
	setUpCalled := false! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/29/2006 18:46'!
methodReturningABlock
	| temp |
	temp := 3.
	^ [temp + 1]! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/29/2006 18:52'!
methodReturningABlock2
	^ [self className]! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/25/2006 09:56'!
setUp
	super setUp.
	setUpCalled := true! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 19:24'!
stringFromPoint2: aPoint
"
	self new stringFromPoint2: 1@1.
	self new stringFromPoint2: 1@2.
	self new stringFromPoint2: 2@1.
	self new stringFromPoint2: 2@2.
"
	aPoint x = 1 ifTrue:[
		aPoint y = 1 ifTrue: [
			^ 'one@one'
		]
		ifFalse: [
			^ 'one@' , aPoint y asString
		]
	]
	ifFalse: [
		aPoint y = 1 ifTrue: [
			^ aPoint x asString , '@one'
		]
		ifFalse: [
			^ aPoint x asString , '@' , aPoint y asString
		]
	]! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 19:22'!
stringFromPoint: aPoint
"
	self new stringFromPoint: 1@1.
	self new stringFromPoint: 1@2.
	self new stringFromPoint: 2@1.
	self new stringFromPoint: 2@2.
"
	^ aPoint x = 1 ifTrue:[
		aPoint y = 1 ifTrue: [
			'one@one'
		]
		ifFalse: [
			'one@' , aPoint y asString
		]
	]
	ifFalse: [
		aPoint y = 1 ifTrue: [
			aPoint x asString , '@one'
		]
		ifFalse: [
			aPoint x asString , '@' , aPoint y asString
		]
	]! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/27/2006 18:21'!
testArray1

	| array |

	array := Array new: 1.
	self
		assert: array size = 1
		description: 'size error'.
	self
		assert: array first isNil
		description: 'should be null'.

	array do:[:each |
		self
			assert: each isNil
			description: 'should be null (do:)'.
	].

	array at: 1 put: 10.
	self
		assert: array first = 10
		description: 'should be 10'.

	array do:[:each |
		self
			assert: each = 10
			description: 'should be 10 (do:)'.
	]! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/28/2006 17:41'!
testArray2

	| array |

	array := Array new: 2.

	self
		assert: array size = 2
		description: 'size error'.

	self
		assert: array first isNil
		description: 'should be null'.

	array do:[:each |
		self
			assert: each isNil
			description: 'should be null (do:)'.
	].

	array at: 1 put: 10.
	array at: 2 put: 20.
	
	self should: array first be: 10.
	self should: array second be: 20.

	array withIndexDo:[:each :index |
		self should: each be: (10 * index).
	].
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/23/2006 16:45'!
testBooBar1

	| fooBar |

	fooBar := S2SFooBar foo: 1 bar: 2.
	self
		assert: fooBar foo = 1
		description: 'foo error'.
	self
		assert: fooBar bar = 2
		description: 'bar error (1)'.

	fooBar bar: 3.
	self
		assert: fooBar bar = 3
		description: 'bar error (2)'.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/31/2006 10:53'!
testClassName

	| cs |
	cs := self
				jsLiteral: '''ST.BaseTestCase'''
				inSmalltalk: [self class name asString].
	
	self assert: cs = self className description: 'expected "' , self className asString , '" but got "' , cs , '"'.

! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/27/2006 18:21'!
testCollect

	| collection collect |

	collection := OrderedCollection new.
	collection add: 1.
	collection add: 2.
	collection add: 3.
	
	collect := collection collect:[:each | each * 2].
	self
		assert: collect size = 3
		description: 'size error'.
	self
		assert: collect first = 2
		description: 'should be 2'.
	self
		assert: collect second = 4
		description: 'should be 4'.
	self
		assert: collect third = 6
		description: 'should be 6'.
! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 18:32'!
testIfFalse

	| result |

	result := (true) ifFalse:[2].
	self should: result be: nil.

	result := (false) ifFalse:[2].
	self should: result be: 2.
	! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 18:31'!
testIfTrue

	| result |

	result := (true) ifTrue:[2].
	self should: result be: 2.

	result := (false) ifTrue:[2].
	self should: result be: nil.
	! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 18:32'!
testIfTrueIfFalse

	| result |

	result := (true) ifTrue:[2] ifFalse:[4].
	self should: result be: 2.

	result := (false) ifTrue:[2] ifFalse:[4].
	self should: result be: 4.
	! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/28/2006 16:25'!
testInspect

	| array |
	
	array := {'foo'. 1@2. true}.
	
	"array inspect."
	! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/27/2006 18:21'!
testLast

	| collection |

	collection := OrderedCollection new.
	collection add: 10.
	collection add: 20.
	collection add: 30.
	
	self
		assert: collection last = 30
		description: 'should be 30'.
! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/29/2006 18:47'!
testMethodReturningABlock

	| block result |

	block := self methodReturningABlock.

	result := block value.
	
	self should: result be: 4! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/29/2006 18:55'!
testMethodReturningABlock2

	| block result |

	block := self methodReturningABlock2.

	result := block value.
	
	self should: result be: self className.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/30/2006 20:58'!
testMultipleAssigment

	| a b |
	a := b := 1.

	self
		should: a
		be: 1.

	self
		should: b
		be: 1.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/24/2006 12:35'!
testNil

	| pepe |

	self
		assert: pepe isNil
		description: 'initial value for temporaries'.

	self assert: (pepe ifNil:['']) = ''.
! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/27/2006 18:24'!
testOrderedCollection1

	| oc |

	oc := OrderedCollection new.
	self
		assert: oc size = 0
		description: 'size error'.

	oc add: 'test1'.
	self
		assert: oc size = 1
		description: 'size error (2)'.
	self
		assert: oc first = 'test1'
		description: 'value error'.

	oc add: 'test2'.
	self
		assert: oc size = 2
		description: 'size error (3)'.
	self
		assert: oc second = 'test2'
		description: 'value error (2)'.

	1 to: 2 do:[:index | oc at: index put: index + 1].
	self should: (oc at: 1) be: 2.
	self should: (oc at: 2) be: 3.
! !

!S2SBaseTestCase methodsFor: 'running - collections' stamp: 'dgd 7/27/2006 18:21'!
testSelect

	| collection selection |

	collection := OrderedCollection new.
	collection add: 1.
	collection add: 2.
	collection add: 3.
	collection add: 4.
	collection add: 5.
	
	selection := collection select:[:each | each < 3].
	self
		assert: selection size = 2
		description: 'size error'.
	self
		assert: selection first = 1
		description: 'should be 1'.
	self
		assert: selection second = 2
		description: 'should be 2'.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/25/2006 09:57'!
testSetUp
	self assert: setUpCalled description: 'setUp not called!!'! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/23/2006 21:37'!
testStaticMethod

	self assert: S2SFooBar isFooBar.

	self assert: S2SFooBarXxx isFooBar.
	! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/26/2006 11:26'!
testString

	| str expected |
	
	str := '
	''\'.

	self
		assert: str size = 4
		description: 'size error (\n\t\''\\)'.

	expected := self
						jsLiteral: '''\n\t\''\\'''
						inSmalltalk: [str].

	self
		assert: str = expected
		description: 'expected: ' , expected asString.
! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 19:30'!
testStringFromPoint1

	self should: (self stringFromPoint: 1@1) be: 'one@one'.
	self should: (self stringFromPoint: 1@2) be: 'one@2'.
	self should: (self stringFromPoint: 2@1) be: '2@one'.
	self should: (self stringFromPoint: 2@2) be: '2@2'.

! !

!S2SBaseTestCase methodsFor: 'running - flow' stamp: 'dgd 7/27/2006 19:30'!
testStringFromPoint2

	self should: (self stringFromPoint2: 1@1) be: 'one@one'.
	self should: (self stringFromPoint2: 1@2) be: 'one@2'.
	self should: (self stringFromPoint2: 2@1) be: '2@one'.
	self should: (self stringFromPoint2: 2@2) be: '2@2'.


! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/30/2006 21:06'!
testStringStreamContents

	| str1 str2 |


	str1 := S2SStringExtension streamContents:[:stream |
		stream nextPutAll: 'bla'
	].

	self assert: str1 = 'bla'.



	str2 := S2SStringExtension streamContents:[:stre |
		stre nextPutAll: 'bla'; tab; cr.
	].

	self assert: str2 = 'bla	
'.
! !

!S2SBaseTestCase methodsFor: 'running - class hierarchy' stamp: 'dgd 8/1/2006 14:39'!
testSubclasses

	| subclasses |
	subclasses := S2SFooBar subclasses.

	self
		should: subclasses size
		be: 1.

	self
		should: subclasses first
		be: S2SFooBarXxx.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/23/2006 17:22'!
testSuper

	| to |

	to := S2SFooBarXxx new.
	to bar: 1.

	self assert: to bar = 2 description: 'expected "2" but got "' , to bar asString , '"'.

! !

!S2SBaseTestCase methodsFor: 'running - class hierarchy' stamp: 'dgd 8/1/2006 14:38'!
testSuperclass

	self
		should: S2SObject superclass
		be: nil.

	self
		should: S2SFooBar superclass
		be: S2SObject.

	self
		should: S2SFooBarXxx superclass
		be: S2SFooBar.
! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:09'!
testWhileFalse

	| index flag |
	index := 1.
	flag := index.
	[index >= 3] whileFalse:[
		index := index + 1.
		flag := flag + 1.
	].

	self assert: flag = 3! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:10'!
testWhileTrue

	| index flag |
	index := 1.
	flag := index.
	[index < 3] whileTrue:[
		index := index + 1.
		flag := flag + 1.
	].

	self assert: flag = 3! !

!S2SBaseTestCase methodsFor: 'running' stamp: 'dgd 7/30/2006 21:06'!
testWriteStream

	| stream |

	stream := S2SStringExtension new writeStream.

	stream nextPutAll: 'bla'.
	self assert: stream contents = 'bla'.

	stream nextPutAll: 'xxx'.
	self assert: stream contents = 'blaxxx'.

	stream tab.
	self assert: stream contents = 'blaxxx	'.

	stream cr.
	self assert: stream contents = 'blaxxx	
'.
! !

S2STestCase subclass: #S2SExampleTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2SExampleTestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 18:41'!
testGreen
	self assert: true! !

!S2SExampleTestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 18:52'!
testRed
	| x |
	x := 1.
	x failingMethod! !

!S2SExampleTestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 18:51'!
testYellow
	self assert: false! !

!S2SExampleTestCase methodsFor: 'running' stamp: 'dgd 7/21/2006 18:18'!
testYellowWithDescription
	self assert: false description: 'A description for the assert condition'! !

S2STestCase subclass: #S2SGeometryTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2SGeometryTestCase class methodsFor: 'as yet unclassified' stamp: 'dgd 7/22/2006 20:45'!
jsClassesToInclude
	^ {S2SPoint}! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:17'!
testPointAbs
	| point |

	point := (-1 @ -2) abs.

	self assert: point x = 1 description: 'invalid x'.
	self assert: point y = 2 description: 'invalid y'.
! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:14'!
testPointAddition1
	| point1 point2 result |

	point1 := 1 @ 2.
	point2 := 4 @ 5.

	result := point1 + point2.

	self assert: result x = 5 description: 'invalid x'.
	self assert: result y = 7 description: 'invalid y'.
! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:13'!
testPointAddition2
	| result |

	result := (1 @ 2) + (4 @ 5).

	self assert: result x = 5 description: 'invalid x'.
	self assert: result y = 7 description: 'invalid y'.
! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 15:13'!
testPointAddition3
	| result |

	result := (1 @ 2) + 4.

	self assert: result x = 5 description: 'invalid x'.
	self assert: result y = 6 description: 'invalid y'.
! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/23/2006 15:35'!
testPointAsString
	| point |

	point := 1 @ 2.

	self assert: point asString = '1@2'! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 20:36'!
testPointInstantiation1
	| point |

	point := S2SPoint x: 1 y: 2.

	self assert: point x = 1 description: 'invalid x'.
	self assert: point y = 2 description: 'invalid y'.
! !

!S2SGeometryTestCase methodsFor: 'running' stamp: 'dgd 7/21/2006 20:49'!
testPointInstantiation2
	| point |

	point := 1 @ 2.

	self assert: point x = 1 description: 'invalid x'.
	self assert: point y = 2 description: 'invalid y'.
! !

!S2STestCase class methodsFor: 'class initialization' stamp: 'dgd 8/2/2006 15:14'!
initialize

	self runAll! !

!S2STestCase class methodsFor: 'javascript-generation' stamp: 'dgd 7/27/2006 16:33'!
jsClassesToInclude
	^ {S2STestResult. S2STestRun. S2STestFailure}! !

!S2STestCase class methodsFor: 'running' stamp: 'dgd 8/2/2006 15:15'!
runAll

	| testCases |
	
	testCases := self allSubclasses select:[:each | each new getTestSelectors notEmpty].

	testCases := testCases reject:[:each | each = S2SExampleTestCase].

	self
		jsLiteral: '	document.body.innerHTML = ''<h3>Running the tests...</h3>'''
		inSmalltalk:[].

	self runAll: testCases.
! !

!S2STestCase class methodsFor: 'running' stamp: 'dgd 8/2/2006 14:31'!
runAll: testCasesCollection

	| testResult  |

	self flag: #todo. "show progress info"
	
	testResult := S2STestResult new.
	
	testCasesCollection inlineDo:[:testCaseClass |
		| testCase |
		testCase := testCaseClass new.
		testCase run: testResult.
	].

"	testResult inspect."
	testResult show.
! !

!S2STestCase methodsFor: 'testing' stamp: 'dgd 8/2/2006 14:21'!
assert: aBoolean

	| failure |
	aBoolean = true inlineIfTrue:[^ self].

	failure := S2STestFailure description: ''.

	self
		jsLiteral: 'throw failure'
		inSmalltalk: [TestFailure signal: 'assert failed']
! !

!S2STestCase methodsFor: 'testing' stamp: 'dgd 8/2/2006 14:19'!
assert: aBoolean description: aString

	| desc2 failure |

	aBoolean = true inlineIfTrue:[^ self].
		
	failure := S2STestFailure description: aString.

	self
		jsLiteral: 'throw failure'
		inSmalltalk: [TestFailure signal: aString]
! !

!S2STestCase methodsFor: 'running' stamp: 'dgd 7/22/2006 20:06'!
getTestSelectors
	| selectors |
	selectors := nil.

	self
		jsLiteral: '
	selectors = new Array();
	for (var key in this) {
		var value = this[key];
		if (typeof value == ''function'') {
			if (key.match(''test'') !!= null) {
				selectors.push(key);
			}
		}
	}
		'
		inSmalltalk: [
			selectors := self class selectors
											collect:[:each | each asString]
											thenSelect:[:each | each beginsWith: 'test']
		].
	
	^ selectors.
! !

!S2STestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 15:16'!
run
	| result |
	result := S2STestResult new.
	self run: result.
	^ result! !

!S2STestCase methodsFor: 'running' stamp: 'dgd 8/2/2006 14:21'!
run: aResult

	| testRun error isFailure desc |

	self getTestSelectors inlineDo:[:eachSelector |
			testRun := S2STestRun testCase: self selector: eachSelector.

			error := nil.

			self
				jsLiteral:'
			try {
				testRun.run();
			}
			catch (err) {
				error = err;
			}
'
				inSmalltalk:[testRun run].
	
			error isNil inlineIfTrue:[
				aResult addPassed: testRun
			]
			ifFalse:[
				isFailure := self
									jsLiteral: '(error.className && (error.className() == "ST.TestFailure"))'
									inSmalltalk:[error isKindOf: TestFailure].

				isFailure inlineIfTrue:[
					aResult addFailure: testRun description: error description
				]
				ifFalse:[
					desc := self
									jsLiteral: '(error.name ? error.name : "") + " " + (error.message || error.description)'
									inSmalltalk:[error description].
					aResult addError: testRun description: desc
				].
			].
	].
! !

!S2STestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 15:50'!
setUp
! !

!S2STestCase methodsFor: 'testing' stamp: 'dgd 7/27/2006 18:27'!
should: result be: expected 
	^ self assert: (result = expected) description: 'should be ' , expected asString , ', but it''s ' , result asString! !

!S2STestCase methodsFor: 'running' stamp: 'dgd 7/20/2006 15:50'!
tearDown
! !

S2SObject subclass: #S2STestFailure
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2STestFailure class methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:18'!
description: aString
	^ self new initializeDescription: aString! !

!S2STestFailure methodsFor: 'accessing' stamp: 'dgd 7/27/2006 18:11'!
description
	^ description! !

!S2STestFailure methodsFor: 'initialization' stamp: 'dgd 7/31/2006 13:18'!
initializeDescription: aString
	description := aString! !

!S2STestFailure methodsFor: 'converting' stamp: 'dgd 7/27/2006 16:36'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ': "'.
	aStream nextPutAll: description asString.
	aStream nextPutAll: '"'.
! !

S2SObject subclass: #S2STestResult
	instanceVariableNames: 'failures errors passed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2STestResult methodsFor: 'accessing' stamp: 'dgd 7/27/2006 12:40'!
addError: aTestRun description: desc

	| d |
	d := desc ifNil:[''].
	errors add: {aTestRun. d}.
! !

!S2STestResult methodsFor: 'accessing' stamp: 'dgd 7/27/2006 16:23'!
addFailure: aTestRun description: desc

	| d |
	d := desc ifNil:[''].
	failures add: {aTestRun. d}.
! !

!S2STestResult methodsFor: 'accessing' stamp: 'dgd 7/20/2006 18:57'!
addPassed: aTestRun

	passed add: aTestRun
! !

!S2STestResult methodsFor: 'utilities' stamp: 'dgd 7/21/2006 17:54'!
clearLog

	self
		jsLiteral: 'document.body.innerHTML = '''''
		inSmalltalk: ["Transcript clear"].
! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 7/21/2006 20:43'!
colorError
	^ 'red'! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 7/21/2006 20:43'!
colorFailure
	^ 'cccc00'! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 7/21/2006 20:42'!
colorPassed
	^ 'green'! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 8/2/2006 14:28'!
headerHtml

	| status resultColor |

	status := self status.
	status = 'passed'
		inlineIfTrue:[ resultColor := '#66ff66' ].
	status = 'failure'
		inlineIfTrue:[ resultColor := 'yellow' ].
	status = 'error'
		inlineIfTrue:[ resultColor := self colorError ].

	^ '
<div style="width: 100%; background-color: ' , resultColor , '">
	<br>
	<font size="+2"><b>&nbsp;&nbsp;&nbsp;Status:&nbsp;<i>' , status , '</i></b></font>
	<br>
	<br>
</div>
<br>
<table border="0" cellspacing="0" celpadding="4">
	<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td bgcolor="#66ff66"><font size="+1">passed:</font></td><td align="right" bgcolor="#66ff66">' , passed size asString , '</td></tr>
	<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td bgcolor="yellow"><font size="+1">failures:</font></td><td align="right" bgcolor="yellow">' , failures size asString , '</td></tr>
	<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;</td><td bgcolor="' , self colorError , '"><font size="+1">errors:</font></td><td align="right" bgcolor="' , self colorError , '">' , errors size asString , '</td></tr>
</table>
<br>
&nbsp;
&nbsp;&nbsp;<a href="#" onClick="ST.TestCase.runAll()">run all</a>
&nbsp;&nbsp;<a href="/ShowJavascriptSource/__all__.js" target="_blank">browse all</a>
&nbsp;&nbsp;<a href="/ShowJavascriptSource/__pre__.js" target="_blank">browse pre</a>
&nbsp;&nbsp;<a href="/ShowJavascriptSource/__post__.js" target="_blank">browse post</a>
<br>
'.
! !

!S2STestResult methodsFor: 'initialization' stamp: 'dgd 7/22/2006 12:23'!
initialize
"	super initialize."

	passed := OrderedCollection new.
	failures := OrderedCollection new.
	errors := OrderedCollection new.
! !

!S2STestResult methodsFor: 'utilities' stamp: 'dgd 7/22/2006 12:29'!
log: anObjectOrString

	| msg |

	msg := anObjectOrString asString.
	
	self
		jsLiteral: 'document.body.innerHTML += msg + ''<br>''' 
		inSmalltalk: [Transcript show: msg; cr].
! !

!S2STestResult methodsFor: 'utilities' stamp: 'dgd 7/28/2006 17:09'!
logCr
	
	self
		jsLiteral: 'document.body.innerHTML += ''<br>'''
		inSmalltalk: [Transcript cr].
! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 7/30/2006 21:06'!
show

	| stream |

	stream := S2SStringExtension new writeStream.
		
	stream nextPutAll: self headerHtml , '<br>'.
	
	stream nextPutAll: '&nbsp;browse class: '.

	self class loadedClassesNames
		do:[:each |
			stream nextPutAll: '<a href="/ShowJavascriptSource/' , each , '.js" target="_blank">'.
			stream nextPutAll: each.
			stream nextPutAll: '</a>'.
		]
		separatedBy:[
			stream nextPutAll: ' | '.
		].
	stream nextPutAll: '<br>'.
	stream nextPutAll: '<br>'.

	errors notEmpty inlineIfTrue:[	
		stream nextPutAll: '&nbsp;<b><i>errors:</i></b><br><table border="0" cellspacing="0">'.
		errors inlineDo:[:each | self showTestRun: each first comment: each second color: self colorError on: stream].
		stream nextPutAll: '</table>'.
		stream nextPutAll: '<br>'.
	].

	failures notEmpty inlineIfTrue:[
		stream nextPutAll: '&nbsp;<b><i>failures:</i></b><br><table border="0" cellspacing="0">'.
		failures inlineDo:[:each | self showTestRun: each first comment: each second color: self colorFailure on: stream].
		stream nextPutAll: '</table>'.
		stream nextPutAll: '<br>'.
	].

	passed notEmpty inlineIfTrue:[
		stream nextPutAll: '&nbsp;<b><i>passed:</i></b><br><table border="0" cellspacing="0">'.
		passed inlineDo:[:each | self showTestRun: each comment: '' color: self colorPassed on: stream].
		stream nextPutAll: '</table>'.
		stream nextPutAll: '<br>'.
	].

	self log: stream contents.
! !

!S2STestResult methodsFor: 'user interface' stamp: 'dgd 7/27/2006 21:46'!
showTestRun: testRun comment: comment color: color on: stream

	| testCase theSelector space |

	testCase := testRun testCase.
	theSelector := testRun selector.

	space := '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
	
	stream nextPutAll: '<tr>'.

	stream nextPutAll: '<td>'.
	stream nextPutAll: space.
	stream nextPutAll: '</td>'.
	stream nextPutAll: '<td>'.
	stream nextPutAll: space.
	stream nextPutAll: '</td>'.

	stream nextPutAll: '<td>'.
	stream nextPutAll: '<font color="'.
	stream nextPutAll:  color.
	stream nextPutAll:  '"><tt><b>'.
	stream nextPutAll: testRun asString.
	stream nextPutAll: '</b></tt></font>'.
	comment isEmpty inlineIfFalse:[
		stream nextPutAll: '<br><i>'.
		stream nextPutAll: comment asString.
		stream nextPutAll: '</i>'
	].
	stream nextPutAll: '</td>'.

	stream nextPutAll: '<td>'.
	stream nextPutAll: space.
	stream nextPutAll: '</td>'.

	stream nextPutAll: '<td>'.
	stream nextPutAll: '<a href="#" onclick="'.
	stream nextPutAll: testRun jsSourceToRun.
	stream nextPutAll: '">run</a>'.
	stream nextPutAll: ' '.
	stream nextPutAll: '<a href="/ShowJavascriptSource/'.
	stream nextPutAll: testRun testCase className.
	stream nextPutAll: '.js?selector='.
	stream nextPutAll: theSelector.
	stream nextPutAll: '" target="_blank">browse</a>'.
	stream nextPutAll: '</td>'.

	stream nextPutAll: '<td>'.
	stream nextPutAll: space.
	stream nextPutAll: '</td>'.

	stream nextPutAll: '<td> (squeak: '.
	stream nextPutAll: '<a href="?testCase='.
	stream nextPutAll: testCase className.
	stream nextPutAll: '&selector='.
	stream nextPutAll: theSelector asString.
	stream nextPutAll: '&operation=run">run</a>'.
	stream nextPutAll: ' '.
	stream nextPutAll: '<a href="?testCase='.
	stream nextPutAll: testCase className.
	stream nextPutAll: '&selector='.
	stream nextPutAll: theSelector asString.
	stream nextPutAll: '&operation=browse">browse</a>'.
	stream nextPutAll: ')</td>'.

	stream nextPutAll: '</tr>'.
	
	^ stream contents
! !

!S2STestResult methodsFor: 'accessing' stamp: 'dgd 7/27/2006 13:27'!
status

	errors isEmpty
		inlineIfFalse: [ ^ 'error' ].

	failures isEmpty
		inlineIfFalse: [ ^ 'failure' ].

	^ 'passed'
! !

S2SObject subclass: #S2STestRun
	instanceVariableNames: 'testCase selector theSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

!S2STestRun class methodsFor: 'instance creation' stamp: 'dgd 7/31/2006 13:09'!
testCase: aClass selector: aSymbol
	^ self new initializeTestCase: aClass selector: aSymbol! !

!S2STestRun methodsFor: 'initialization' stamp: 'dgd 7/31/2006 13:09'!
initializeTestCase: aClass selector: aSymbol
	testCase := aClass.
	selector := aSymbol.
! !

!S2STestRun methodsFor: 'accessing' stamp: 'dgd 7/25/2006 19:59'!
jsSourceToRun
	^ 'var tc = new ' , testCase className , '(); tc.setUp(); tc.' , selector asString , '(); tc.tearDown();'! !

!S2STestRun methodsFor: 'converting' stamp: 'dgd 7/25/2006 19:59'!
printOn: aStream
	aStream nextPutAll: testCase className.
	aStream nextPutAll: '>>'.
	aStream nextPutAll: selector asString.
! !

!S2STestRun methodsFor: 'running' stamp: 'dgd 7/25/2006 19:59'!
run
	[
		testCase setUp.
		testCase perform: selector asSymbol.
	]
	ensure: [
		testCase tearDown
	].! !

!S2STestRun methodsFor: 'accessing' stamp: 'dgd 7/25/2006 19:59'!
selector
	^ selector! !

!S2STestRun methodsFor: 'accessing' stamp: 'dgd 7/21/2006 19:34'!
testCase
	^ testCase! !

S2SObject subclass: #S2SWriteStream
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2SWriteStream methodsFor: 'accessing' stamp: 'dgd 7/23/2006 12:30'!
contents
	^ self
			jsLiteral: 'this._buffer.join('''')'
			inSmalltalk:[
				String streamContents:[:stream |
					buffer do:[:each |
						stream nextPutAll: each.
					].				
				].
			].
! !

!S2SWriteStream methodsFor: 'stream protocol' stamp: 'dgd 7/23/2006 12:26'!
cr
	self nextPutAll: '
'! !

!S2SWriteStream methodsFor: 'initialization' stamp: 'dgd 7/23/2006 12:23'!
initialize
	buffer := OrderedCollection new.! !

!S2SWriteStream methodsFor: 'stream protocol' stamp: 'dgd 7/23/2006 12:23'!
nextPutAll: aString
	buffer add: aString! !

!S2SWriteStream methodsFor: 'stream protocol' stamp: 'dgd 7/23/2006 12:25'!
tab
	self nextPutAll: '	'! !

Object subclass: #S2STestModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-SUnit'!

S2STestModule class
	instanceVariableNames: 'instance'!

S2STestModule class
	instanceVariableNames: 'instance'!

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/25/2006 14:49'!
assembleService: assembly

	assembly alias: '/JavascriptSource' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processJavascriptSourceRequest:
									argument: nil).
	].

	assembly alias: '/ShowJavascriptSource' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processShowJavascriptSourceRequest:
									argument: nil).
	].

	assembly alias: '/' to: [
		assembly addPlug: (MessageSend
									receiver: self instance
									selector: #processRootRequest:
									argument: nil).
	].
! !

!S2STestModule class methodsFor: 'instance creation' stamp: 'dgd 7/21/2006 12:16'!
clearInstance
	"Clear the receiver (singleton) instance"
	"
	S2STestModule clearInstance.
	"

	instance := nil
! !

!S2STestModule class methodsFor: 'class initialization' stamp: 'dgd 8/1/2006 12:21'!
initialize
	self openWorkspace! !

!S2STestModule class methodsFor: 'instance creation' stamp: 'dgd 7/21/2006 12:16'!
initializeInstance
	"Initialize the receiver (singleton) instance"

	instance := self new.
! !

!S2STestModule class methodsFor: 'instance creation' stamp: 'dgd 7/21/2006 12:16'!
instance
	"Answer the (singleton) instance of the receiver"
	"
	S2STestModule instance.
	"
	instance ifNil: [self initializeInstance].
	^ instance! !

!S2STestModule class methodsFor: 'class initialization' stamp: 'dgd 8/1/2006 12:21'!
openWorkspace
	"
	S2STestModule openWorkspace.
	"
	'"
St 2 jS - Test Runner

This is a small, but still useful, SUnit framework developed to test JS generated code.  The test methods in S2SBaseTestCase and S2SGeometryTestCase are good examples of what is possible to do.

Some assorted features:
- The TestCases can run on the internet browser, but also in Squeak.
- From the TestRunner (in the internet browser) you can browse the test code in Squeak, run in Squeak, (re)run in the internet browser, etc.
- A simple inspector (to inspect the JS object in the internet browser) is provided.  To see it in action, just uncomment the last statement in S2SBaseTestCase>>testInspect and reload the test-runner in the internet browser.

How to run:
- Check the port in S2STestModule class>>servicePort, the default is 9999
- Start the service
- open your internet browser pointing to http://localhost:9999
"
S2STestModule start.
S2STestModule stop.
S2STestModule reset.
'  openInWorkspaceWithTitle: 'St 2 jS - Test Runner'! !

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/21/2006 12:17'!
reset
	"Reset the receiver"
	"
	S2STestModule reset.
	"
	self stop.
	self clearInstance.
	self start.
! !

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/21/2006 12:17'!
serviceName
	"Answer the receiver's intented service name"

	^ 'Test Module'! !

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/21/2006 12:17'!
servicePort
	"Answer the receiver's intented service port"

	^ 9999! !

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/21/2006 12:21'!
start
	"Start the stuff needed to serve"
	"
	S2STestModule start.
	"

	| assembly service |

	self stop.

	assembly := ModuleAssembly core.
	
	self assembleService: assembly.

	service := HttpService
						startOn: self servicePort
						named: self serviceName.

	service plug: assembly rootModule.
	"service setDeploymentMode."
	service setDebugMode.
! !

!S2STestModule class methodsFor: 'running' stamp: 'dgd 7/21/2006 12:17'!
stop
	"Stop the associated services"

	(HttpService servicesNamed: self serviceName)
		do: [:each |
				each stop.
				each waitForStop.
				each kill.
				each unregister].

	instance isNil ifFalse:[instance stop].
! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 8/2/2006 15:06'!
allJsClasses

	| result |

	result := Set new.

	result addAll: S2SObject jsWithAllClassesToInclude.
	result addAll: S2STestCase jsWithAllClassesToInclude.

	S2STestCase allSubclasses do:[:each |
		result addAll: each jsWithAllClassesToInclude.
	].

	^ result
! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 8/2/2006 14:40'!
htmlSource
"
	S2STestCase htmlSource.
	Clipboard clipboardText: S2STestCase htmlSource.
"

	| steps |
	
	steps := self javascriptSteps.

	^ '<html>
	<head>
		<title>St2jS - Test Runner</title>
		<style>
	html {
		height: 100%;
		border: 0px;
	}

	body {
		margin: 0px;
		height: 100%;
		background-color: #FFFFFF;
		cursor: default;
	}
	</style>

		<script type="text/javascript">
			document.writeln(''<p>&nbsp;</p><div style="position: relative; left: 15%; top: 15%; width: 70%; background-color: #f6f6ff; border: 2px solid #000033;"><h3>&nbsp;&nbsp;Loading...</h3><center><i><b><font size="-1"><p id="messageW">message</p></font></b></i></center><div style="position: relative; left: 10%; width: 80%; background-color: #ccccff; border: 1px solid #000033;"><div id="barW" style="width:0%; background-color: #333366;">-</div></div><p>&nbsp;</p></div>'');

			// No var, to use delete
			ExpectedLoadSteps = ' , steps asString , ';
			LoadStep = 0;

			// This sintax, to use delete
			setPercentAndMessage = function(message) {
				var percent = Math.min(LoadStep / ExpectedLoadSteps * 100, 100);

				var barW = document.getElementById("barW");
				var messageW = document.getElementById("messageW");

				barW.style.width = percent + "%";
				barW.innerHTML = "<font color=''white''><b>&nbsp;" + Math.round(percent) + "%</b></font>";

				var msg;
				msg = message + " (" + LoadStep + "/" + ExpectedLoadSteps + ")";
				messageW.innerHTML = msg;

				window.status = "Loading: " + Math.round(percent) + "%   - " + msg + "...";
			}

			setPercentAndMessage("");

			// This sintax, to use delete
			doLoadStep = function(name) {
				LoadStep++;

				setPercentAndMessage(name);
				
				if (LoadStep == ExpectedLoadSteps) {
					document.body.innerHTML = '''';
					window.status = "";

					// removes initial objects, no more needed after loading.
					delete LoadStep;
					delete ExpectedLoadSteps;
					delete doLoadStep;
					delete setPercentAndMessage;
				}
			}
		</script>

		<script type="text/javascript">
			function fullLoaded() {
				// Do something, all resources (including scripts) where loaded
			}
		</script>

		<!!-- ------------------------------------------------------- -->
		<!!-- Javascript source -->

' , self includeJavascriptSource , '
		<!!-- ------------------------------------------------------- -->
	</head>

	<body onLoad="fullLoaded()">
		<!!-- who needs a body with a big head? -->
	</body>
</html>
'! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 8/2/2006 15:06'!
includeEmbeddedJavascript
	^ true! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 7/31/2006 19:52'!
includeJavascriptInSteps
	^ true! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 8/1/2006 13:56'!
includeJavascriptSource

	| stream |

	stream := String new writeStream.

	self includeJavascriptInSteps ifTrue:[
		| classes |

		stream nextPutAll: ('<!!-- Include JavaScript in {1} steps (__pree__, classes and  __post__) -->' format: {self javascriptSteps}); cr.

		stream nextPutAll: '<!!-- First the pre  -->'; cr.
		self includeJavascriptSource: '__pre__' on: stream.

		stream nextPutAll: '<!!-- Then the classes  -->'; cr.
		classes := self allJsClasses asSortedCollection:[:x :y | x jsGoesBefore: y].
		classes do:[:each |
			self includeJavascriptSource: each jsClassName on: stream.
		].

		stream nextPutAll: '<!!-- Finally the post  -->'; cr.
		self includeJavascriptSource: '__post__' on: stream.
	]
	ifFalse: [
		stream nextPutAll: '<!!-- Include all JavaScript code in a shot -->'; cr.
		self includeJavascriptSource: '__all__' on: stream.
	].

	^ stream contents.
! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 7/28/2006 16:26'!
includeJavascriptSource: sourceNameString on: stream

	self includeEmbeddedJavascript ifTrue: [
		stream nextPutAll: '<!!-- Embedded: "' , sourceNameString , '" -->'; cr.
		stream nextPutAll: '<script type=''text/javascript''>'; cr.
		stream nextPutAll: ((self updateLoadProgressIndicator: sourceNameString) , (self sourceForClass: sourceNameString)) withoutTrailingBlanks; cr.
		stream nextPutAll: '</script>'; cr; cr.
	]
	ifFalse: [
		stream nextPutAll: '<script type=''text/javascript'' src=''/JavascriptSource/' , sourceNameString , '.js''></script>'; cr
	]

! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 8/1/2006 13:55'!
isValidClassName: sourceName

	(#('__all__' '__pre__' '__post__') includes: sourceName)
		ifTrue:[^ true].
		
	^ self allJsClasses anySatisfy:[:each | each jsClassName = sourceName]! !

!S2STestModule methodsFor: 'private' stamp: 'dgd 8/1/2006 13:55'!
javascriptSteps
	^ self includeJavascriptInSteps
					ifTrue: [self allJsClasses size + (2 "__pree__ and __post__")]
					ifFalse:[1].
! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/28/2006 13:17'!
processJavascriptSourceRequest: aRequest 

	| sourceName response |

	sourceName := self sourceNameFrom: aRequest.

	(self isValidClassName: sourceName) ifFalse:[
		^HttpResponse 
				status: #notFound 
				contents: 'The object you requested was not found on this server.'
	].

	response := (self updateLoadProgressIndicator: sourceName) , (self sourceForClass: sourceName).

	^ HttpResponse
				fromString: response
				contentType: 'text/javascript'
! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/31/2006 13:16'!
processRootRequest: aRequest 

	| htmlSource |
	
	aRequest fields
					at: 'operation'
					ifPresent:[:operation |
		| testCase selector |

		testCase := aRequest fields at: 'testCase'.
		(testCase beginsWith: 'ST.')
			ifTrue:[testCase := testCase allButFirst: 3].
		selector := aRequest fields at: 'selector'.

		Smalltalk at: ('S2S' , testCase) asSymbol ifPresent:[:klass |
			operation = 'browse'
				ifTrue:[
					WorldState addDeferredUIMessage: [
						Browser fullOnClass: klass selector: selector
					].
				].
			operation = 'run'
				ifTrue:[
					WorldState addDeferredUIMessage: [
						| testRun |
						testRun := S2STestRun testCase: klass new selector: selector.
						testRun run.
					].
				].
		].
	
		^  HttpResponse redirectTo: '/'
	].
	
	htmlSource := self htmlSource.

	^ htmlSource asHttpResponseTo: aRequest.! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/26/2006 12:27'!
processShowJavascriptSourceRequest: aRequest 

	| sourceName selectorName |

	sourceName := self sourceNameFrom: aRequest.
	selectorName := aRequest fields at: 'selector' ifAbsent:[nil].
	
	(self isValidClassName: sourceName) ifFalse:[
		^HttpResponse 
				status: #notFound 
				contents: 'The object you requested was not found on this server.'
	].

	^ HttpResponse
			fromString: (self sourceForClass: sourceName selector: selectorName)
			contentType: 'text/plain'
! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/26/2006 12:22'!
sourceForClass: sourceName
	^ self sourceForClass: sourceName selector: nil! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 8/2/2006 13:26'!
sourceForClass: sourceName selector: selectorName

	| translator |

	translator := S2STranslator new.

	"
	translator showSmalltalkSource: false.
	translator showMethodComments: false.
	"
	
	(sourceName = '__all__')
		ifTrue: [ ^ translator allJsSourceFor: self allJsClasses ].

	(sourceName = '__pre__')
		ifTrue:[ ^ translator preJsSourceFor: self allJsClasses ].
				
	(sourceName = '__post__')
		ifTrue:[ ^ translator postJsSourceFor: self allJsClasses ].
				
	selectorName isNil
		ifTrue:[ ^ translator sourceForClassJsNamed: sourceName ].
	
	^ translator sourceForClassJsNamed: sourceName selector: selectorName.
! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/26/2006 12:11'!
sourceNameFrom: aRequest 

	| sourceName |

	sourceName := aRequest fields at: 'source' ifAbsent:[
		| path |
		path := ModCore path.
		(path beginsWith: '/')
			ifTrue:[path := path allButFirst].
		path
	].

	(sourceName endsWith:'.js')
		ifTrue:[sourceName := sourceName allButLast: 3].

	^ sourceName
! !

!S2STestModule methodsFor: 'running' stamp: 'dgd 7/21/2006 12:23'!
stop

	"The service is stoping, clean up if necessary"! !

!S2STestModule methodsFor: 'processing' stamp: 'dgd 7/28/2006 13:17'!
updateLoadProgressIndicator: sourceName

	^ '/**-----------------------------------------------------------**/
/* Try to update the load progress indicator */
try {
	doLoadStep(''' , sourceName , ''');
} catch(err) {
	/* just ignore */
}
/**-----------------------------------------------------------**/

'! !

Object subclass: #S2STranslator
	instanceVariableNames: 'selectorMapping showSmalltalkSource showMethodComments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ST2JS-Core'!

!S2STranslator class methodsFor: 'class initialization' stamp: 'dgd 8/1/2006 12:15'!
initialize

	self openWorkspace.! !

!S2STranslator class methodsFor: 'class initialization' stamp: 'dgd 8/1/2006 12:19'!
openWorkspace
	"
	S2STranslator openWorkspace.
	"
	'"
St2jS - Smalltalk to Javascript translator

Some hints to start to explore this code:
- S2SObject is the superclass of the generated classes
- S2SObjectExtension is the superclass for the ''extension'' classes. Extension-classes are places to put modifications to already existing classes in JS.

Some assorted features:
- The generated code is as readable as possible. The identation is almost fine, comments are included, and the ST source code is included, in comments, for reference.
- A simple inspector (to inspect the JS object in the internet browser) is provided.  To see it in action follow the instructions in ''St 2 jS - Test Runner'' workspace.
- The classes can declare dependencies to other classes.
	- See implementors of #jsClassesToInclude
- The classes can include plain JS code. Useful for utilities funcions.
	- See implementors of #jsLibrarySource
- The ST statements are translated to equivalent JS statements.
	- See implementors of #jsSourceOn:level:translator:
	- See S2STranslator>>initializeSelectorMapping
	- See S2STranslator>>selectorMappingFor:
"

"Generate all the JS source for all the subclasses of S2SObject.  It means ALL the code."
S2STranslator new allJsSource.

"Generate the JS code for the given method"
S2STranslator new methodSourceFor: S2SBaseTestCase selector: #testInspect.
S2STranslator new methodSourceFor: S2SBaseTestCase selector: #testOrderedCollection1.

'  openInWorkspaceWithTitle: 'St 2 jS - Smalltalk to Javascript translator'
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 18:42'!
allJsSource
	"Answer the source for the receiver and all the receiver's subclasses including the necessary library source."

	^ self allJsSourceFor: S2SObject withAllSubclasses! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 8/2/2006 13:33'!
allJsSourceFor: classesCollection
	"Answer the JS source for the given classes collection including the necessary library source."

	| result sortedClasses |

	result := String new writeStream.

	sortedClasses := classesCollection asSortedCollection:[:x :y | x jsGoesBefore: y].

	result nextPutAll: (self preJsSourceFor: classesCollection) withBlanksTrimmed.
	result cr.
	result cr.

	sortedClasses do: [:each |
		result nextPutAll: (self sourceForClass: each) withBlanksTrimmed.
		result cr.
		result cr.
	].

	result nextPutAll: (self postJsSourceFor: classesCollection) withBlanksTrimmed.
	result cr.

	^ result contents.
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 20:11'!
classJsNamed: aString 
	^ S2SObject withAllSubclasses detect:[:each | each jsClassName = aString]! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 18:40'!
classMethodSourceFor: aClass selector: selector 
	"Answer the JS source for the given class"

	| result |

	result := String new writeStream.

	self classMethodSourceFor: aClass selector: selector  on: result.

	^ result contents withBlanksTrimmed.
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 7/31/2006 21:24'!
classMethodSourceFor: aClass selector: selector on: aStream

	| sc node jsClassName result |

	result := String new writeStream.

	sc := (aClass class ultimateSourceCodeAt: selector ifAbsent:[^ self]) asString.
	node := Parser parserClass new parse: sc class: aClass class.

	showSmalltalkSource ifTrue:[
		result
			nextPutAll: '/*' ;
			cr;
			nextPutAll: aClass name asString; nextPutAll:' class>>';
			nextPutAll: node asString;
			cr;
			nextPutAll: '*/' ; cr.
	].

	showMethodComments ifTrue:[
		| comment |
		comment := aClass class supermostPrecodeCommentFor: selector.
		comment isNil ifFalse:[
			comment := comment copyReplaceAll: String cr with: ' '.
			comment := comment copyReplaceAll: '  ' with: ' '.
			result
				nextPutAll: '/* ';
				nextPutAll: comment;
				nextPutAll: ' */';
				cr.
		].
	].
	
	jsClassName := aClass jsClassName.
	result
		nextPutAll: '{1}.{2} = ' format: { jsClassName. self convertSelectorToJsMethodName: selector}.

	node jsSourceOn: result level: 0 translator: self.

	result
		nextPutAll: ';';
		cr;
		cr.

	aStream nextPutAll: (self postProcessJsSource: result contents withBlanksTrimmed).
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/2/2006 13:35'!
classMethodsSourceFor: aClass on: aStream 

	self superclassesClassMethodsFor: aClass on:  aStream.

	(self classSelectorsFor: aClass class)
		do:[:eachSelector | self classMethodSourceFor: aClass selector: eachSelector on: aStream].
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/2/2006 13:21'!
classNameFor: aClass on: aStream 

	aStream
		nextPutAll: ('{1}.__className__ = ''{1}'';' format: {aClass jsClassName});
		cr.

	aStream
		nextPutAll: ('{1}.prototype.__className__ = ''{1}'';' format: {aClass jsClassName});
		cr.
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 8/1/2006 14:06'!
classSelectorsFor: aClass
"
	^ (aClass selectors reject:[:each | (each beginsWith: 'js') or:[each beginsWith: 'new'] or:[each beginsWith: 'initialize']]) asSortedCollection
"
	^ (aClass selectors reject:[:each | (each beginsWith: 'js')]) asSortedCollection! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 20:07'!
constructorFor: aClass 
	| result |

	result := String new writeStream.

	self constructorFor: aClass on: result.

	^ result contents withBlanksTrimmed! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 7/31/2006 20:05'!
constructorFor: aClass on: aStream 
	aStream
		nextPutAll: '{1} = function() \{' format: {aClass jsClassName};
		cr.

	aClass allInstVarNames do:[:each |
		aStream
			nextPutAll: '	this._{1} = null;' format: {each};
			cr.
	].
"
	aStream
		nextPutAll: '	this.initialize();';
		cr.
"
	aStream
		nextPutAll: '}';
		cr.
! !

!S2STranslator methodsFor: 'accessing - mapping' stamp: 'dgd 8/1/2006 14:30'!
convertJsMethodNameToSelector: jsMethodName

	| map |
	
	map := Dictionary new.
	
	map at: '__add__' put: #+.
	map at: '__sub__' put: #-+.
	map at: '__mul__' put: #*.
	map at: '__div__' put: #/.
	map at: '__at__' put: #@.

	map at: '__name__' put: #name.
	map at: '__class__' put: #class.
	map at: '__inspect__' put: #inspect.
	map at: '__new__' put: #new.

	map at: 'toString' put: #asString.

	^  map
			at: jsMethodName
			ifAbsent:[(jsMethodName copyReplaceAll: '_' with: ':') asSymbol].
! !

!S2STranslator methodsFor: 'accessing - mapping' stamp: 'dgd 8/1/2006 14:31'!
convertSelectorToJsMethodName: selector

	| map |
	
	map := Dictionary new.
	
	map at: #+ put: '__add__'.
	map at: #- put: '__sub__'.
	map at: #* put: '__mul__'.
	map at: #/ put: '__div__'.
	map at: #@put: '__at__'.

	map at: #name put: '__name__'.
	map at: #class put: '__class__'.
	map at: #inspect put: '__inspect__'.
	map at: #new put: '__new__'.

	map at: #asString put: 'toString'.

	^  map
			at: selector
			ifAbsent:[selector asString copyReplaceAll: ':' with: '_'].
! !

!S2STranslator methodsFor: 'accessing - mapping' stamp: 'dgd 7/31/2006 20:58'!
defaultMapping: selectorSymbol

	^ '%receiver%.' , (self convertSelectorToJsMethodName: selectorSymbol) , '(%args%)'
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 19:55'!
inheritanceFor: aClass 
	| result |

	result := String new writeStream.

	self inheritanceFor: aClass on: result.

	^ result contents withBlanksTrimmed.! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/1/2006 11:12'!
inheritanceFor: aClass on: aStream 
	
	aClass jsIsRoot
		ifTrue:[^ self].

	aStream
		nextPutAll: '{1}.superclass_({2});' format: {aClass jsClassName. aClass superclass jsClassName};
		cr.
! !

!S2STranslator methodsFor: 'initialization' stamp: 'dgd 7/31/2006 21:21'!
initialize

	self initializeSelectorMapping.
	showSmalltalkSource := true.
	showMethodComments := true.! !

!S2STranslator methodsFor: 'initialization' stamp: 'dgd 8/1/2006 13:30'!
initializeSelectorMapping

	selectorMapping := Dictionary new.

	"debugging"
	selectorMapping at: #flag: put: ''.

	"testing"
	selectorMapping at: #isNil put: '(%receiver% == null)'.
	selectorMapping at: #notNil put: '(%receiver% !!= null)'.

	"equality"
	selectorMapping at: #= put: '(%receiver% == %arg1%)'.
	selectorMapping at: #~= put: '(%receiver% !!= %arg1%)'.

	"comparation"
	selectorMapping at: #> put: '(%receiver% > %arg1%)'.
	selectorMapping at: #>= put: '(%receiver% >= %arg1%)'.
	selectorMapping at: #< put: '(%receiver% < %arg1%)'.
	selectorMapping at: #<= put: '(%receiver% <= %arg1%)'.
	selectorMapping at: #between:and: put: '((%receiver% >= %arg1%) && (%receiver% <= %arg2%))'.

	"condition concatenation"
	selectorMapping at: #& put: '(%receiver% && %arg1%)'.
	selectorMapping at: #| put: '(%receiver% || %arg1%)'.
	selectorMapping at: #and: put: '(%receiver% && %arg1%)'.
	selectorMapping at: #and:and: put: '(%receiver% && %arg1% && %arg2%)'.
	selectorMapping at: #or: put: '(%receiver% || %arg1%)'.
	selectorMapping at: #or:or: put: '(%receiver% || %arg1% || %arg2%)'.

	"negation"
	selectorMapping at: #not put: '!!(%receiver%)'.

	"string manipulation"
	selectorMapping at: #asString put: 'ST.toString(%receiver%)'.
	selectorMapping at: #printString put: 'ST.printString(%receiver%)'.
	selectorMapping at: #printOn: put: 'ST.printOn_(%receiver%, %arg1%)'.
	selectorMapping at: #asSymbol put: '%receiver%'.
	selectorMapping at: #asUppercase put: '%receiver%.toUpperCase()'.
	selectorMapping at: #asLowercase put:  '%receiver%.toLowerCase()'.
	selectorMapping at: #, put: '(%receiver% + %arg1%)'.
	
	"collection"
	selectorMapping at: #size put: '%receiver%.length'.
	selectorMapping at: #add: put: '%receiver%.push(%arg1%)'.

	"aritmethic"
	selectorMapping at: #+ put: '%receiver%.__add__(%arg1%)'.
	selectorMapping at: #- put: '%receiver%.__sub__(%arg1%)'.
	selectorMapping at: #* put: '%receiver%.__mul__(%arg1%)'.
	selectorMapping at: #/ put: '%receiver%.__div__(%arg1%)'.
	selectorMapping at: #@ put: '%receiver%.__at__(%arg1%)'.
	selectorMapping at: #squared put: '(%receiver% * %receiver%)'.
	selectorMapping at: #negated put: '(%receiver% * -1)'.

	"conditionals"
	selectorMapping at: #ifTrue: put: '%receiver%.ifTrue_(%arg1%)'.
	selectorMapping at: #ifFalse: put: '%receiver%.ifFalse_(%arg2%)'.
	selectorMapping at: #ifNil: put: 'ST.ifNil(%receiver%, %arg1% )'.
	selectorMapping at: #whileTrue: put: '(%receiver%).whileTrue_(%arg1%)'.
	selectorMapping at: #whileFalse: put: '(%receiver%).whileFalse_(%arg1%)'.

	selectorMapping at: #class put: '%receiver%.__class__()'.

	"inlines"
	selectorMapping at: #inlineIfTrue: put: #jsInlineIfTrueOn:level:translator:.
	selectorMapping at: #inlineIfTrue:ifFalse: put: #jsInlineIfTrueIfFalseOn:level:translator:.
	selectorMapping at: #inlineIfFalse: put: #jsInlineIfFalseOn:level:translator:.
	selectorMapping at: #inlineDo: put: #jsInlineDoOn:level:translator:.
	selectorMapping at: #inlineWhileTrue: put: #jsInlineWhileTrueOn:level:translator:.
	selectorMapping at: #inlineWhileFalse: put: #jsInlineWhileFalseOn:level:translator:.
	selectorMapping at: #inlineIsEmpty put: #jsInlineIsEmptyOn:level:translator:.
	selectorMapping at: #inlineNotEmpty put: #jsInlineNotEmptyOn:level:translator:.
	
	"loops"
	selectorMapping at: #to:by:do: put: #jsInlineToByDoOn:level:translator:.
		
	"accessing"
	selectorMapping at: #at:put: put: '%receiver%[%arg1% - 1] = %arg2%'.
	selectorMapping at: #at: put: '%receiver%[%arg1% - 1]'.
	selectorMapping at: #first put: '%receiver%[0]'.
	selectorMapping at: #second put: '%receiver%[1]'.
	selectorMapping at: #third put: '%receiver%[2]'.
	selectorMapping at: #last put: '%receiver%[%receiver%.length - 1]'.
	
	"user interface"
	selectorMapping at: #inform: put: 'alert(%arg1%)'.
	
	"try/catch"
	selectorMapping at: #ensure: put: '(%receiver%).ensure_(%arg1%)'.

	"perform"
	selectorMapping at: #perform: put: '%receiver%[%arg1%]()'.

	"Blocks evaluation"
	selectorMapping at: #value put: '%receiver%()'.
	selectorMapping at: #value: put: '%receiver%(%arg1%)'.
	selectorMapping at: #value:value: put: '%receiver%(%arg1%, %arg2%)'.
	selectorMapping at: #value:value:value: put: '%receiver%(%arg1%, %arg2%, %arg3%)'.
	
	"Accessing"
	selectorMapping at: #instVarNamed: put: '%receiver%[%arg1%]'.
	! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 7/31/2006 19:51'!
loadedClass: aClass on: aStream 
	aStream nextPutAll: 'ST.LoadedClasses.push(' , aClass jsClassName , ')'; cr.
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 19:26'!
methodSourceFor: aClass selector: selector 
	"Answer the JS source for the given class"

	| result |

	result := String new writeStream.

	self methodSourceFor: aClass selector: selector  on: result.

	^ result contents withBlanksTrimmed.
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 7/31/2006 21:24'!
methodSourceFor: aClass selector: selector on: aStream

	| sc node jsClassName  result |

	result := String new writeStream.

	sc := (aClass ultimateSourceCodeAt: selector ifAbsent:[^ self]) asString.
	node := Parser parserClass new parse: sc class: aClass.

	showSmalltalkSource ifTrue:[
		result
			nextPutAll: '/*' ;
			cr;
			nextPutAll: aClass name asString; nextPutAll:'>>';
			nextPutAll: node asString;
			cr;
			nextPutAll: '*/' ; cr.
	].

	showMethodComments ifTrue:[
		| comment |
		comment := aClass supermostPrecodeCommentFor: selector.
		comment isNil ifFalse:[
			comment := comment copyReplaceAll: String cr with: ' '.
			comment := comment copyReplaceAll: '  ' with: ' '.
			result
				nextPutAll: '/* ';
				nextPutAll: comment;
				nextPutAll: ' */';
				cr.
		].
	].
	
	jsClassName := aClass jsClassName.
	result
		nextPutAll: '{1}.prototype.{2} = ' format: { jsClassName. self convertSelectorToJsMethodName: selector }.

	node jsSourceOn: result level: 0 translator: self.

	result
		nextPutAll: ';';
		cr;
		cr.

	aStream nextPutAll: (self postProcessJsSource: result contents withBlanksTrimmed).
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 7/31/2006 19:41'!
methodsSourceFor: aClass on: aStream 
	| sortedSelectors |

	sortedSelectors := (aClass selectors copyWithoutAll: #(#jsLiteral: #jsLiteral:inSmalltalk:)) asSortedCollection.
	"sortedSelectors := self jsSelectors asSortedCollection."
	
	sortedSelectors
		do:[:each | self methodSourceFor: aClass selector: each on: aStream].
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 20:12'!
minimumJsSource

	| result |
	
	result := Set new.

	result add: S2SObject.
	result add: S2SReturnValue.
	result add: S2SInspector.
	result add: S2SWriteStream.

	^ self allJsSourceFor: result.
	! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 8/1/2006 13:58'!
postJsSourceFor: classesCollection
	"Answer the library source for the given classes collection"

	| result sortedClasses |

	result := String new writeStream.

	sortedClasses := classesCollection asSortedCollection:[:x :y | x jsGoesBefore: y].

	sortedClasses
		select:[:each | each class includesSelector: #jsPostSource]
		thenDo:[:each |
			result
				nextPutAll: '/**-----------------------------------------------------------**/'; cr;
				nextPutAll: '/* Post-code generated from: ' , each name asString , ' class>>jsPostSource */'; cr;
				nextPutAll: each jsPostSource withBlanksTrimmed; cr;
				nextPutAll: '/**-----------------------------------------------------------**/'; cr; cr.
		].

	^ result contents.
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/1/2006 14:45'!
postProcessJsSource: aString

	| str |

	str := aString withBlanksTrimmed.
	
	str := str copyReplaceAll: ';
;' with: ';'.
	str := str copyReplaceAll: ' += 1' with: '++'.
	str := str copyReplaceAll: ' -= 1' with: '--'.
	str := str copyReplaceAll: '(	' with: '('.
	str := str copyReplaceAll: ';
)' with: ')'.

	[str includesSubString: '(	'] whileTrue:[
		str := str copyReplaceAll: '(	' with: '('.
	].
	[str includesSubString: '!!	'] whileTrue:[
		str := str copyReplaceAll: '!!	' with: '!!'.
	].
	[str includesSubString: '[	'] whileTrue:[
		str := str copyReplaceAll: '[	' with: '['.
	].
	[str includesSubString: ' 	'] whileTrue:[
		str := str copyReplaceAll: ' 	' with: ' '.
	].

	str := str copyReplaceAll: 'OrderedCollection.__new__()' with: '[]'.
	str := str copyReplaceAll: 'OrderedCollection' with: 'Array'.
	str := str copyReplaceAll: ';;' with: ';'.
	str := str copyReplaceAll: '}
;' with: '};'.
	
	
	^ str! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 8/1/2006 13:58'!
preJsSourceFor: classesCollection
	"Answer the library source for the given classes collection"

	| result sortedClasses |

	result := String new writeStream.

	sortedClasses := classesCollection asSortedCollection:[:x :y | x jsGoesBefore: y].

	sortedClasses
		select:[:each | each class includesSelector: #jsPreSource]
		thenDo:[:each |
			result
				nextPutAll: '/**-----------------------------------------------------------**/'; cr;
				nextPutAll: '/* Pre-code generated from: ' , each name asString , ' class>>jsPreSource */'; cr;
				nextPutAll: each jsPreSource withBlanksTrimmed; cr;
				nextPutAll: '/**-----------------------------------------------------------**/'; cr; cr.
		].

	^ result contents.
! !

!S2STranslator methodsFor: 'accessing - mapping' stamp: 'dgd 7/31/2006 20:58'!
selectorMappingFor: aMessageNode

	| selectorSymbol |
	
	(#(jsLiteral: jsLiteral:inSmalltalk:) includes: aMessageNode selector selector) ifTrue:[
		^ aMessageNode arguments first key asString
	].

	(aMessageNode receiver notNil and: [aMessageNode receiver isSuper]) ifTrue:[
		^ '%receiver%(''%selectorAsJsMethodName%''%commaArgs%)'
	].

	selectorSymbol := aMessageNode selector selector.

	^ selectorMapping
					at: selectorSymbol
					ifAbsent:[self defaultMapping: selectorSymbol].
! !

!S2STranslator methodsFor: 'accessing' stamp: 'dgd 7/31/2006 21:22'!
showMethodComments: aBoolean 
	showMethodComments := aBoolean! !

!S2STranslator methodsFor: 'translation - options' stamp: 'dgd 7/31/2006 20:10'!
showSmalltalkSource
	"Answer if the receiver will include the ST source as a comment for the JS generated method"
	^ showSmalltalkSource! !

!S2STranslator methodsFor: 'accessing' stamp: 'dgd 7/31/2006 21:20'!
showSmalltalkSource: aBoolean
	showSmalltalkSource := aBoolean! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 20:14'!
sourceForClass: aClass
	"Answer the JS source for the given class"

	| result |

	result := String new writeStream.

	result
		nextPutAll: '/**-----------------------------------------------------------**/'; cr;
		nextPutAll: '/** Generated from: ' , aClass name asString , ' **/'; cr.

	self sourceForClass: aClass on: result.

	result cr.
	result
		nextPutAll: '/**-----------------------------------------------------------**/'; cr; cr.

	^ result contents withBlanksTrimmed.
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/2/2006 13:31'!
sourceForClass: aClass on: aStream

	| result |
	result := String new writeStream.

	aClass jsIsExtension ifTrue:[
		result nextPutAll: '/** extension class, no constructor nor inheritance **/'; cr.	
	]
	ifFalse:[
		result nextPutAll: '/** constructor **/'; cr.
		self constructorFor: aClass on: result.
		result cr.	

		result nextPutAll: '/** inheritance **/'; cr.	
		self inheritanceFor: aClass on: result.
		result cr.	
	].

	result nextPutAll: '/** loaded class **/'; cr.	
	self loadedClass: aClass on: result.
	result cr.	

	result nextPutAll: '/** class name **/'; cr.	
	self classNameFor: aClass on: result.
	result cr.	

	result nextPutAll: '/** class methods **/'; cr.	
	self classMethodsSourceFor: aClass on: result.
	result cr.	

	result nextPutAll: '/** instance methods **/'; cr.
	self methodsSourceFor: aClass on: result.
	result cr.	

	aStream nextPutAll: (self postProcessJsSource: result contents withBlanksTrimmed).
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 7/31/2006 20:14'!
sourceForClassJsNamed: nameString

	| klass source |

	klass := self classJsNamed: nameString.
	source := self sourceForClass: klass.

	^ source
! !

!S2STranslator methodsFor: 'translation' stamp: 'dgd 8/2/2006 13:14'!
sourceForClassJsNamed: nameString selector: selectorString

	| klass source |

	klass := self classJsNamed: nameString.
	
	source := self methodSourceFor: klass selector: (self convertJsMethodNameToSelector: selectorString).

	^ source
! !

!S2STranslator methodsFor: 'private' stamp: 'dgd 8/2/2006 13:55'!
superclassesClassMethodsFor: aClass on: aStream 
	"snapshot inheritance for class methods"

	aClass jsSuperclasses
		reject:[:eachSuperclass | aClass jsIsExtension and: [eachSuperclass jsIsRoot]]
		thenDo:[:eachSuperclass |
				(self classSelectorsFor: eachSuperclass class)
					do:[:eachSelector |
						aStream nextPutAll: ('{1}.{3} = {2}.{3};' format: {aClass jsClassName. eachSuperclass jsClassName. self convertSelectorToJsMethodName:eachSelector }).
						aStream cr.
					].
	].
! !

!BlockNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/20/2006 11:58'!
arguments
	^ arguments! !

!BlockNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:31'!
hasBlockNodeWithReturn

	^ statements anySatisfy:[: each | each isReturnNode or:[each hasBlockNodeWithReturn]]! !

!BlockNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 8/1/2006 13:30'!
jsInlinedSourceOn: aStream level: anInteger translator: aTranslator

	(temporaries notNil and:[temporaries notEmpty]) ifTrue:[
		anInteger + 1 timesRepeat: [aStream tab].
		aStream nextPutAll: 'var '.
		temporaries
			do:[:each | aStream nextPutAll: each name , ' = null']
			separatedBy: [ aStream nextPutAll: ', '].
		aStream nextPutAll: ';'; cr.
	].

	statements do: [:each |
		| eachSource |

		eachSource := each jsSourceLevel: anInteger + 1 translator: aTranslator.
		eachSource := eachSource copyReplaceAll: '%return%' with: 'return '.

		aStream nextPutAll: eachSource.

		aStream contents withoutTrailingBlanks last = $}
			ifFalse:[aStream nextPutAll: ';'].
		aStream contents withoutTrailingBlanks last = Character cr
			ifFalse:[aStream cr].
	].

! !

!BlockNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:24'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	anInteger timesRepeat: [aStream tab].
	aStream nextPutAll: 'function ('.
	arguments
		do:[:each | aStream nextPutAll: each key]
		separatedBy:[aStream nextPutAll: ', '].
	aStream nextPutAll: ') {'; cr.

	arguments do:[:each |
		anInteger + 1 timesRepeat: [aStream tab].
		aStream
			nextPutAll: '{1} = (typeof {1} == ''undefined'') ? null : {1};' format: {each key};
			cr.
	].

	(temporaries notNil and:[temporaries notEmpty]) ifTrue:[
		anInteger + 1 timesRepeat: [aStream tab].
		aStream nextPutAll: 'var '.
		temporaries
			do:[:each | aStream nextPutAll: each name , ' = null']
			separatedBy: [ aStream nextPutAll: ', '].
		aStream nextPutAll: ';'; cr.
	].

	statements size > 1 ifTrue:[
		statements allButLast do: [:each |
			each jsSourceOn: aStream level: anInteger + 1 translator: aTranslator.
			
			aStream contents withoutTrailingBlanks last = $}
				ifFalse:[aStream nextPutAll: ';'].
			aStream contents withoutTrailingBlanks last = Character cr
				ifFalse:[aStream cr].
		].
	].
	anInteger + 1 timesRepeat: [aStream tab].
	statements last isReturnNode ifFalse: [
		aStream nextPutAll: 'return '.
	].

	aStream nextPutAll: ((statements last jsSourceLevel: 0 translator: aTranslator) copyReplaceAll: '%return%' with: 'throw __returnValue__.value_').
	aStream cr.
			
	anInteger timesRepeat: [aStream tab].
	aStream nextPutAll: '}'.
! !

!BraceNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:29'!
hasBlockNodeWithReturn
	^ elements anySatisfy:[:each | each hasBlockNodeWithReturn]! !

!BraceNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:49'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	anInteger timesRepeat: [aStream tab].

	aStream nextPutAll: '['.
	elements
		do:[:each | aStream nextPutAll: (each jsSourceLevel: anInteger translator: aTranslator)]
		separatedBy:[aStream nextPutAll: ', '].
	aStream nextPutAll: ']'.
! !

!WriteStream methodsFor: '*ST2JS-accessing' stamp: 'dgd 7/19/2006 09:49'!
nextPutAll: aString format: aCollection 
	self nextPutAll: (aString format: aCollection)! !

!AssignmentNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:31'!
hasBlockNodeWithReturn
	^ value hasBlockNodeWithReturn! !

!AssignmentNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:22'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	anInteger timesRepeat: [aStream tab].

	variable jsSourceOn: aStream level: 0 translator: aTranslator.
	
	aStream nextPutAll: ' = '.
	
	value jsSourceOn: aStream level: 0 translator: aTranslator.
! !

!ParseNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/26/2006 21:03'!
isReturnNode
	^ false! !

!ParseNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/20/2006 18:05'!
isSuper
	^ false! !

!ParseNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:27'!
jsSourceLevel: anInteger translator: aTranslator
	| result |
	
	result := String new writeStream.
	
	self jsSourceOn: result level: anInteger translator: aTranslator.
	
	^ result contents! !

!ParseNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:22'!
jsSourceOn: aStream level: anInteger translator: aTranslator
	self subclassResponsibllity! !

!CascadeNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/29/2006 19:31'!
hasBlockNodeWithReturn
	^ receiver hasBlockNodeWithReturn or:[messages anySatisfy:[:each | each hasBlockNodeWithReturn]]! !

!CascadeNode methodsFor: '*ST2JS-javascript generation' stamp: 'dgd 7/31/2006 20:43'!
jsSourceOn: aStream level: anInteger translator: aTranslator

	| index |
	
	anInteger timesRepeat: [aStream tab].
	
	aStream
		nextPutAll: '(function(__receiver__) { '.

	index := 0.
	messages do:[:each |
		| eachJsSource |
		index := index + 1.

		eachJsSource := (each jsSourceLevel: anInteger translator: aTranslator).
		eachJsSource := eachJsSource copyReplaceAll: '%receiver%' with: '__receiver__'.

		(index = messages size) ifTrue:[
			aStream
				nextPutAll: 'return ';
				nextPutAll: eachJsSource;
				nextPutAll: ';'
		]
		ifFalse:[
			aStream
				nextPutAll: eachJsSource;
				nextPutAll: '; '.
		].
	].

	aStream nextPutAll: ' })(' , (receiver jsSourceLevel: anInteger translator: aTranslator) , ')'.
! !
S2SObject initialize!
S2STestCase initialize!
S2STestModule initialize!
S2STranslator initialize!
